---
layout: post
title: "v0.1.15 Dispatch Release"
year: 2018
---

# v0.1.15 Dispatch Release

[Download v0.1.15](https://github.com/vmware/dispatch/releases/tag/v0.1.15)

## Source Directory Support for Functions

Sometimes it's hard to package up a function in a single file.  Functions have dependencies, and it's not always easy
to add those dependencies into the image.  In order to address this use-case, we've added support for function source
directories.  This change necessitates some changes to the CLI.  This also allowed us to make other function CLI changes
which we've been waiting on for a while.

### What's changed

For single file functions, the CLI is largely the same.  The only noticable change is that the image name is no longer
a positional argument:

Old:

    dispatch create function python3 hello-py hello.py

New:

    dispatch create function hello-py hello.py --image python3

### What's new

Let's use this same example to show the source directory support.  First we'll place this same `hello.py` file in a new directory (let's call it `hello`):

    $ tree hello
    hello
    └── hello.py

Now to create the same function using the source directory is:

    dispatch create function hello-py-dir ./hello --handler hello.handle --image python3

The value for handler is language specific, and represents the import path to the function entry point.

## Language Packs have Moved

Language support packs have been moved out of the main github repository and now reside in [github.com/dispatchframework](https://github.com/dispatchframework).

* [Node](https://github.com/dispatchframework/nodejs-base-image)
* [Python3](https://github.com/dispatchframework/python3-base-image)
* [Powershell](https://github.com/dispatchframework/powershell-base-image)
* [Java](https://github.com/dispatchframework/java-base-image)
* [Clojure](https://github.com/dispatchframework/clojure-base-image)