---
layout: post
title: "v0.1.17 Dispatch Release"
year: 2018
---

# v0.1.17 Dispatch Release

[Download v0.1.17](https://github.com/vmware/dispatch/releases/tag/v0.1.17)

 
## Support for seeding Dispatch with images
It has never been easier to run your first function on Dispatch! We have added a new CLI command to seed your Dispatch setup with the
base-images and images of commonly used languages in the Dispatch community. Simply run the following command against your Dispatch installation:
```shell
$ dispatch create seed-images
Created BaseImage: nodejs-base
Created BaseImage: python3-base
Created BaseImage: powershell-base
Created BaseImage: java-base
Created Image: nodejs
Created Image: python3
Created Image: powershell
Created Image: java
```

You should then be able to view a list of base-images and images that were added to your setup wit the following commands:
```shell
$ dispatch get base-images
       NAME       |                   URL                   | STATUS |         CREATED DATE
---------------------------------------------------------------------------------------------------
  nodejs-base     | dispatchframework/nodejs-base:0.0.8     | READY  | Tue Jun 12 18:39:04 PDT 2018
  powershell-base | dispatchframework/powershell-base:0.0.9 | READY  | Tue Jun 12 18:39:05 PDT 2018
  java-base       | dispatchframework/java-base:0.0.9       | READY  | Tue Jun 12 18:39:05 PDT 2018
  python3-base    | dispatchframework/python3-base:0.0.8    | READY  | Tue Jun 12 18:39:05 PDT 2018


$ dispatch get images
     NAME    | URL |    BASEIMAGE    | STATUS |         CREATED DATE
----------------------------------------------------------------------------
  nodejs     |     | nodejs-base     | READY  | Tue Jun 12 18:39:05 PDT 2018
  python3    |     | python3-base    | READY  | Tue Jun 12 18:39:05 PDT 2018
  powershell |     | powershell-base | READY  | Tue Jun 12 18:39:05 PDT 2018
  java       |     | java-base       | READY  | Tue Jun 12 18:39:05 PDT 2018
 
```

You are now all set to write your function in one of these languages. For more detailed steps please follow the instructions in the [examples](https://vmware.github.io/dispatch/documentation/guides/quickstart#get-the-examples) section of our QuickStart guide.

## Improved IAM bootstrap workflow
When you install Dispatch with [authentication](https://vmware.github.io/dispatch/documentation/guides/setup-authentication), you need to add the initial
authorization policies before you can use the setup. This is akin to setting up an administrative account in your new laptop. Previously, the workflow to
bootstrap Dispatch with the policies included several commands that has now been consolidated into a single `dispatch manage bootstrap` command.

This is a privileged command (similar to `dispatch install`) and thus requires access to the underlying Kubernetes cluster on which Dispatch is installed. Ensure this by pointing your `kubectl` config file to the
right cluster.

Run the command by specifying the email address of a valid user from your Identity Provider (e.g github) to the `dispatch manage bootstrap` command. e.g

```shell
$ dispatch manage bootstrap --bootstrap-user xyz@example.com
Enabling bootstrap mode
waiting for bootstrap status....success
Creating Organization: default
Creating Policy: default-policy
Disabling bootstrap mode (takes up to 30s to take effect)
waiting for bootstrap status....success
```

This single command will force Dispatch to enter a special bootstrap mode, add the initial policies and then disable the bootstrap mode. The specified user is configured with an
authorization policy that allows full administrative access of Dispatch. You can now run other dispatch commands or add [additional policies](https://vmware.github.io/dispatch/documentation/guides/setup-authentication#7-configuring-additional-policies)
to onboard more users.

## CLI command to print version information

A new CLI Command `dispatch version` has been added to print the client and server versions. The server version corresponds to the dispatch deployment that is configured
in the current context of the dispatch config file `HOME/.dispatch/config.json`. The support for CLI contexts was added in the previous [release](https://vmware.github.io/dispatch/2018/06/06/v0-1-16-release.html).

```shell
$ dispatch version --json
{
  "client": {
    "version": "v0.1.16-5-gf535bc07",
    "commit": "f535bc07c3f84ce2ad9f296c1eaca9aab45aa853",
    "buildDate": "2018-06-06T17:23:30Z",
    "goVersion": "go1.10.2",
    "compiler": "gc",
    "platform": "darwin/amd64"
  },
  "server": {
    "version": "v0.1.16-5-gf535bc07",
    "commit": "f535bc07c3f84ce2ad9f296c1eaca9aab45aa853",
    "buildDate": "2018-06-06T17:23:30Z",
    "goVersion": "go1.10.2",
    "compiler": "gc",
    "platform": "linux/amd64"
  }
}
``` 


