---
layout: post
title: "v0.1.18 Dispatch Release"
year: 2018
---

# v0.1.18 Dispatch Release

[Download v0.1.18](https://github.com/vmware/dispatch/releases/tag/v0.1.18)


## Dispatch installation on EKS
New guide on installing [Dispatch on EKS](https://vmware.github.io/dispatch/documentation/guides/eks).

## Limited Multi-Tenancy Support
Dispatch now has limited support for multi-tenancy. You now have the ability to create organizations and defines policies to give access to users on those organizations. 

However, this is only soft-multitenancy since it will not isolate the function execution environments or control the network policies for pods running on Kubernetes.

To create an organization:
```bash
$ dispatch iam create organization <organization_name>
```

Users can specify the organization that they wish to access either by using the `--organization` flag or setting it in the Dispatch config file.

## Support for function creation errors
Now when a functions fails, you can find out what went wrong by examing the new `reason` field on the function object.

When a function fails to be created:
```bash
$ dispatch get images
  NAME | URL | BASEIMAGE | STATUS | CREATED DATE
--------------------------------------------

$ dispatch create function fail Fail.java --image=java
Created function: fail

$ dispatch get functions
  NAME | FUNCTIONIMAGE | STATUS |         CREATED DATE
-----------------------------------------------------------
  fail |               | ERROR  | Tue Jun 19 15:40:27 PDT 2018
```

You can examine the function object to see the error:
```bash
$ dispatch get function fail --json | jq -r .reason
[
  "Error when fetching image for function fail: failed to get image: 'java': [Code: 404] image java not found"
]
```