---
layout: post
title: "v0.1.19 Dispatch Release"
year: 2018
---

# v0.1.19 Dispatch Release

[Download v0.1.19](https://github.com/vmware/dispatch/releases/tag/v0.1.19)


## Support for Exposed Event Driver
Events may now be pushed (as opposed to pulled) from event sources to Dispatch.  An *exposed* driver will create an ingress route and service to recieve events.
When creating event driver type, use `--expose` to create exposed drivers, these drivers will have a URL which events can be pushed to.
```bash
$ dispatch create eventdrivertype eventgrid dispatchframework/events-eventgrid:0.0.1 --expose
Created event driver type: eventgrid
```
The `EXPOSE` field of created event driver type should be true:
```bash
$ dispatch get eventdrivertype
 NAME   |                IMAGE                 | EXPOSE
-----------------------------------------------------------
  eventgrid | dispatchframework/events-eventgrid:0.0.1 | true
-----------------------------------------------------------
```
Next, to create exposed driver:
```bash
$ dispatch create eventdriver eventgrid --name eventgrid
Created event driver: eventgrid
```
And After the driver was created successfully, we should see an URL:
```bash
$ dispatch get eventdriver
    NAME    |   TYPE    | STATUS | SECRETS | CONFIG |                  URL                    | REASON
-------------------------------------------------------------------------------------------------------
  eventgrid | eventgrid | READY  |         |        | https://example.com/driver/dispatch/... |
-------------------------------------------------------------------------------------------------------
```
and we can push events to this URL which the event driver will receive and process:
```bash
$ curl -i https://example.com/driver/dispatch/... -H 'Content-Type: application/cloudevents+json' -d @event.json
HTTP/2 200
server: nginx/1.13.12
date: Tue, 26 Jun 2018 17:53:54 GMT
content-length: 0
strict-transport-security: max-age=15724800; includeSubDomains
```


## Update to Support Latest Cloud Event Implementation
Dispatch now follows the latest [Cloud Events specification](https://github.com/cloudevents/spec/blob/a12b6b618916c89bfa5595fc76732f07f89219b5/spec.md)). `SourceType` and `EventType` were consolidated into one field, after the change, to add a new subscription for the `vm.being.created` event in a vcenter event driver, run:
```bash
$ dispatch create subscription --event-type vm.being.created myFunction
```

Detailed guide [Working with Events](https://vmware.github.io/dispatch/documentation/guides/working-with-events).


