---
layout: post
title: "v0.1.20 Dispatch Release"
year: 2018
---

# v0.1.20 Dispatch Release

[Download v0.1.20](https://github.com/vmware/dispatch/releases/tag/v0.1.20)


## Last/Follow Support in CLI for Function Runs

It can be a pain to track the output of function runs, especially if they are executed asynchronously or via an
event subscription.  There can often me hundreds or more executions for a single function that's been running for
a while.  In order to make developing and debugging a little easier the `--last` and `--follow` options have been
added to the CLI as a convenience:

```
$ dispatch get run --json --last
```

Simply returns the last function execution.  Adding the function name, filters the result by function name:

```
$ dispatch get run [function name] --json --last
```

To get a stream of function executions as they happen, use the `--follow` option:

```
$ dispatch get run [function name] --json --follow
```

The CLI will poll every second for new executions.

## API Gateway Endpoints Now Namespaced with Org Name

Now that Dispatch supports multiple organizations, the API Gateway needs to organization aware.  In order to ensure
that all API paths defined are unique per-organization, the organization name is prepended to the path.  So if the
following path is defined:

```
$ dispatch create api get-hello hello --method GET --path /hello
```

The created path will show the organization name:

```
$ dispatch get api
    NAME    | FUNCTION | PROTOCOL  | METHOD | DOMAIN |       PATH      |  AUTH  | STATUS | ENABLED
--------------------------------------------------------------------------------------------------
  get-hello | hello    | http      | GET    |        | /dispatch/hello | public | READY  | true
            |          | https     |        |        |                 |        |        |
--------------------------------------------------------------------------------------------------
```

