---
layout: post
title: "v0.1.21 Dispatch Release"
year: 2018
---

# v0.1.21 Dispatch Release

[Download v0.1.21](https://github.com/vmware/dispatch/releases/tag/v0.1.21)

- [[Issue #518](https://github.com/vmware/dispatch/issues/518)] **Single-binary, local version of Dispatch Server:**
This release includes a single-binary dispatch-server. You can run this server locally on your desktop without a need
to provision Kubernetes - the only requirement is Docker. This should cover use cases like local development, proofs of concept,
or a small deployment for personal needs. To use it, simply download the `dispatch-server` binary for your platform,
and run `dispatch-server local`.
    
    *Note:* The local version supports all commands/resources except:
    - event drivers
    - services 

## Add Org to bulk create CLI

You can now create multiple Organizations in bulk using the create command. You can specify your orgs in a yaml file like this:
```
kind: Organization
name: VMware
---
kind: Organization
name: Pivotal
---
kind: Organization
name: Acme Inc.
```

Then you can create these orgs using the following command, assuming your named your file `orgs.yaml`

```
$ dispatch create -f orgs.yaml
```

## Ingress class option

You can now target different ingress controllers in your deployments. In your values.yaml file you can specify the class like this:

```
apiGateway:
  host: 192.168.64.26
dispatch:
  host: 192.168.64.26
  debug: true
  image:
    tag: v0.1.21
    host: vmware
  ingress:
    class: nginx
```

This is useful for clusters with multiple ingress controllers. This class is the same kubernetes.io/ingress.class and can take any value that annotation can.