///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package base_image

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// DeleteBaseImageByNameReader is a Reader for the DeleteBaseImageByName structure.
type DeleteBaseImageByNameReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteBaseImageByNameReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewDeleteBaseImageByNameOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewDeleteBaseImageByNameBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewDeleteBaseImageByNameUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewDeleteBaseImageByNameForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewDeleteBaseImageByNameNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewDeleteBaseImageByNameDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteBaseImageByNameOK creates a DeleteBaseImageByNameOK with default headers values
func NewDeleteBaseImageByNameOK() *DeleteBaseImageByNameOK {
	return &DeleteBaseImageByNameOK{}
}

/*DeleteBaseImageByNameOK handles this case with default header values.

successful operation
*/
type DeleteBaseImageByNameOK struct {
	Payload *v1.BaseImage
}

func (o *DeleteBaseImageByNameOK) Error() string {
	return fmt.Sprintf("[DELETE /{baseImageName}][%d] deleteBaseImageByNameOK  %+v", 200, o.Payload)
}

func (o *DeleteBaseImageByNameOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.BaseImage)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBaseImageByNameBadRequest creates a DeleteBaseImageByNameBadRequest with default headers values
func NewDeleteBaseImageByNameBadRequest() *DeleteBaseImageByNameBadRequest {
	return &DeleteBaseImageByNameBadRequest{}
}

/*DeleteBaseImageByNameBadRequest handles this case with default header values.

Invalid ID supplied
*/
type DeleteBaseImageByNameBadRequest struct {
	Payload *v1.Error
}

func (o *DeleteBaseImageByNameBadRequest) Error() string {
	return fmt.Sprintf("[DELETE /{baseImageName}][%d] deleteBaseImageByNameBadRequest  %+v", 400, o.Payload)
}

func (o *DeleteBaseImageByNameBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBaseImageByNameUnauthorized creates a DeleteBaseImageByNameUnauthorized with default headers values
func NewDeleteBaseImageByNameUnauthorized() *DeleteBaseImageByNameUnauthorized {
	return &DeleteBaseImageByNameUnauthorized{}
}

/*DeleteBaseImageByNameUnauthorized handles this case with default header values.

Unauthorized Request
*/
type DeleteBaseImageByNameUnauthorized struct {
	Payload *v1.Error
}

func (o *DeleteBaseImageByNameUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /{baseImageName}][%d] deleteBaseImageByNameUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteBaseImageByNameUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBaseImageByNameForbidden creates a DeleteBaseImageByNameForbidden with default headers values
func NewDeleteBaseImageByNameForbidden() *DeleteBaseImageByNameForbidden {
	return &DeleteBaseImageByNameForbidden{}
}

/*DeleteBaseImageByNameForbidden handles this case with default header values.

access to this resource is forbidden
*/
type DeleteBaseImageByNameForbidden struct {
	Payload *v1.Error
}

func (o *DeleteBaseImageByNameForbidden) Error() string {
	return fmt.Sprintf("[DELETE /{baseImageName}][%d] deleteBaseImageByNameForbidden  %+v", 403, o.Payload)
}

func (o *DeleteBaseImageByNameForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBaseImageByNameNotFound creates a DeleteBaseImageByNameNotFound with default headers values
func NewDeleteBaseImageByNameNotFound() *DeleteBaseImageByNameNotFound {
	return &DeleteBaseImageByNameNotFound{}
}

/*DeleteBaseImageByNameNotFound handles this case with default header values.

Base image not found
*/
type DeleteBaseImageByNameNotFound struct {
	Payload *v1.Error
}

func (o *DeleteBaseImageByNameNotFound) Error() string {
	return fmt.Sprintf("[DELETE /{baseImageName}][%d] deleteBaseImageByNameNotFound  %+v", 404, o.Payload)
}

func (o *DeleteBaseImageByNameNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteBaseImageByNameDefault creates a DeleteBaseImageByNameDefault with default headers values
func NewDeleteBaseImageByNameDefault(code int) *DeleteBaseImageByNameDefault {
	return &DeleteBaseImageByNameDefault{
		_statusCode: code,
	}
}

/*DeleteBaseImageByNameDefault handles this case with default header values.

Generic error response
*/
type DeleteBaseImageByNameDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the delete base image by name default response
func (o *DeleteBaseImageByNameDefault) Code() int {
	return o._statusCode
}

func (o *DeleteBaseImageByNameDefault) Error() string {
	return fmt.Sprintf("[DELETE /{baseImageName}][%d] deleteBaseImageByName default  %+v", o._statusCode, o.Payload)
}

func (o *DeleteBaseImageByNameDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
