///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package base_image

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetBaseImageByNameParams creates a new GetBaseImageByNameParams object
// with the default values initialized.
func NewGetBaseImageByNameParams() *GetBaseImageByNameParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &GetBaseImageByNameParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetBaseImageByNameParamsWithTimeout creates a new GetBaseImageByNameParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetBaseImageByNameParamsWithTimeout(timeout time.Duration) *GetBaseImageByNameParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &GetBaseImageByNameParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: timeout,
	}
}

// NewGetBaseImageByNameParamsWithContext creates a new GetBaseImageByNameParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetBaseImageByNameParamsWithContext(ctx context.Context) *GetBaseImageByNameParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &GetBaseImageByNameParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		Context: ctx,
	}
}

// NewGetBaseImageByNameParamsWithHTTPClient creates a new GetBaseImageByNameParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetBaseImageByNameParamsWithHTTPClient(client *http.Client) *GetBaseImageByNameParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &GetBaseImageByNameParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,
		HTTPClient:       client,
	}
}

/*GetBaseImageByNameParams contains all the parameters to send to the API endpoint
for the get base image by name operation typically these are written to a http.Request
*/
type GetBaseImageByNameParams struct {

	/*XDispatchOrg*/
	XDispatchOrg *string
	/*XDispatchProject*/
	XDispatchProject *string
	/*BaseImageName
	  Name of base image to return

	*/
	BaseImageName string
	/*Tags
	  Filter based on tags

	*/
	Tags []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get base image by name params
func (o *GetBaseImageByNameParams) WithTimeout(timeout time.Duration) *GetBaseImageByNameParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get base image by name params
func (o *GetBaseImageByNameParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get base image by name params
func (o *GetBaseImageByNameParams) WithContext(ctx context.Context) *GetBaseImageByNameParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get base image by name params
func (o *GetBaseImageByNameParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get base image by name params
func (o *GetBaseImageByNameParams) WithHTTPClient(client *http.Client) *GetBaseImageByNameParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get base image by name params
func (o *GetBaseImageByNameParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the get base image by name params
func (o *GetBaseImageByNameParams) WithXDispatchOrg(xDispatchOrg *string) *GetBaseImageByNameParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the get base image by name params
func (o *GetBaseImageByNameParams) SetXDispatchOrg(xDispatchOrg *string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithXDispatchProject adds the xDispatchProject to the get base image by name params
func (o *GetBaseImageByNameParams) WithXDispatchProject(xDispatchProject *string) *GetBaseImageByNameParams {
	o.SetXDispatchProject(xDispatchProject)
	return o
}

// SetXDispatchProject adds the xDispatchProject to the get base image by name params
func (o *GetBaseImageByNameParams) SetXDispatchProject(xDispatchProject *string) {
	o.XDispatchProject = xDispatchProject
}

// WithBaseImageName adds the baseImageName to the get base image by name params
func (o *GetBaseImageByNameParams) WithBaseImageName(baseImageName string) *GetBaseImageByNameParams {
	o.SetBaseImageName(baseImageName)
	return o
}

// SetBaseImageName adds the baseImageName to the get base image by name params
func (o *GetBaseImageByNameParams) SetBaseImageName(baseImageName string) {
	o.BaseImageName = baseImageName
}

// WithTags adds the tags to the get base image by name params
func (o *GetBaseImageByNameParams) WithTags(tags []string) *GetBaseImageByNameParams {
	o.SetTags(tags)
	return o
}

// SetTags adds the tags to the get base image by name params
func (o *GetBaseImageByNameParams) SetTags(tags []string) {
	o.Tags = tags
}

// WriteToRequest writes these params to a swagger request
func (o *GetBaseImageByNameParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XDispatchOrg != nil {

		// header param X-Dispatch-Org
		if err := r.SetHeaderParam("X-Dispatch-Org", *o.XDispatchOrg); err != nil {
			return err
		}

	}

	if o.XDispatchProject != nil {

		// header param X-Dispatch-Project
		if err := r.SetHeaderParam("X-Dispatch-Project", *o.XDispatchProject); err != nil {
			return err
		}

	}

	// path param baseImageName
	if err := r.SetPathParam("baseImageName", o.BaseImageName); err != nil {
		return err
	}

	valuesTags := o.Tags

	joinedTags := swag.JoinByFormat(valuesTags, "multi")
	// query array param tags
	if err := r.SetQueryParam("tags", joinedTags...); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
