///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package base_image

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// GetBaseImagesHandlerFunc turns a function with the right signature into a get base images handler
type GetBaseImagesHandlerFunc func(GetBaseImagesParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetBaseImagesHandlerFunc) Handle(params GetBaseImagesParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetBaseImagesHandler interface for that can handle valid get base images params
type GetBaseImagesHandler interface {
	Handle(GetBaseImagesParams, interface{}) middleware.Responder
}

// NewGetBaseImages creates a new http.Handler for the get base images operation
func NewGetBaseImages(ctx *middleware.Context, handler GetBaseImagesHandler) *GetBaseImages {
	return &GetBaseImages{Context: ctx, Handler: handler}
}

/*GetBaseImages swagger:route GET / baseImage getBaseImages

List all existing base images

*/
type GetBaseImages struct {
	Context *middleware.Context
	Handler GetBaseImagesHandler
}

func (o *GetBaseImages) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetBaseImagesParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
