///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package endpoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewDeleteEndpointParams creates a new DeleteEndpointParams object
// with the default values initialized.
func NewDeleteEndpointParams() *DeleteEndpointParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &DeleteEndpointParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteEndpointParamsWithTimeout creates a new DeleteEndpointParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDeleteEndpointParamsWithTimeout(timeout time.Duration) *DeleteEndpointParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &DeleteEndpointParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: timeout,
	}
}

// NewDeleteEndpointParamsWithContext creates a new DeleteEndpointParams object
// with the default values initialized, and the ability to set a context for a request
func NewDeleteEndpointParamsWithContext(ctx context.Context) *DeleteEndpointParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &DeleteEndpointParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		Context: ctx,
	}
}

// NewDeleteEndpointParamsWithHTTPClient creates a new DeleteEndpointParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewDeleteEndpointParamsWithHTTPClient(client *http.Client) *DeleteEndpointParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &DeleteEndpointParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,
		HTTPClient:       client,
	}
}

/*DeleteEndpointParams contains all the parameters to send to the API endpoint
for the delete endpoint operation typically these are written to a http.Request
*/
type DeleteEndpointParams struct {

	/*XDispatchOrg*/
	XDispatchOrg *string
	/*XDispatchProject*/
	XDispatchProject *string
	/*Endpoint
	  Name of Endpoint to work on

	*/
	Endpoint string
	/*Tags
	  Filter based on tags

	*/
	Tags []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the delete endpoint params
func (o *DeleteEndpointParams) WithTimeout(timeout time.Duration) *DeleteEndpointParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete endpoint params
func (o *DeleteEndpointParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete endpoint params
func (o *DeleteEndpointParams) WithContext(ctx context.Context) *DeleteEndpointParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete endpoint params
func (o *DeleteEndpointParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete endpoint params
func (o *DeleteEndpointParams) WithHTTPClient(client *http.Client) *DeleteEndpointParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete endpoint params
func (o *DeleteEndpointParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the delete endpoint params
func (o *DeleteEndpointParams) WithXDispatchOrg(xDispatchOrg *string) *DeleteEndpointParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the delete endpoint params
func (o *DeleteEndpointParams) SetXDispatchOrg(xDispatchOrg *string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithXDispatchProject adds the xDispatchProject to the delete endpoint params
func (o *DeleteEndpointParams) WithXDispatchProject(xDispatchProject *string) *DeleteEndpointParams {
	o.SetXDispatchProject(xDispatchProject)
	return o
}

// SetXDispatchProject adds the xDispatchProject to the delete endpoint params
func (o *DeleteEndpointParams) SetXDispatchProject(xDispatchProject *string) {
	o.XDispatchProject = xDispatchProject
}

// WithEndpoint adds the endpoint to the delete endpoint params
func (o *DeleteEndpointParams) WithEndpoint(endpoint string) *DeleteEndpointParams {
	o.SetEndpoint(endpoint)
	return o
}

// SetEndpoint adds the endpoint to the delete endpoint params
func (o *DeleteEndpointParams) SetEndpoint(endpoint string) {
	o.Endpoint = endpoint
}

// WithTags adds the tags to the delete endpoint params
func (o *DeleteEndpointParams) WithTags(tags []string) *DeleteEndpointParams {
	o.SetTags(tags)
	return o
}

// SetTags adds the tags to the delete endpoint params
func (o *DeleteEndpointParams) SetTags(tags []string) {
	o.Tags = tags
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteEndpointParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XDispatchOrg != nil {

		// header param X-Dispatch-Org
		if err := r.SetHeaderParam("X-Dispatch-Org", *o.XDispatchOrg); err != nil {
			return err
		}

	}

	if o.XDispatchProject != nil {

		// header param X-Dispatch-Project
		if err := r.SetHeaderParam("X-Dispatch-Project", *o.XDispatchProject); err != nil {
			return err
		}

	}

	// path param endpoint
	if err := r.SetPathParam("endpoint", o.Endpoint); err != nil {
		return err
	}

	valuesTags := o.Tags

	joinedTags := swag.JoinByFormat(valuesTags, "multi")
	// query array param tags
	if err := r.SetQueryParam("tags", joinedTags...); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
