///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package endpoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// AddEndpointHandlerFunc turns a function with the right signature into a add endpoint handler
type AddEndpointHandlerFunc func(AddEndpointParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn AddEndpointHandlerFunc) Handle(params AddEndpointParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// AddEndpointHandler interface for that can handle valid add endpoint params
type AddEndpointHandler interface {
	Handle(AddEndpointParams, interface{}) middleware.Responder
}

// NewAddEndpoint creates a new http.Handler for the add endpoint operation
func NewAddEndpoint(ctx *middleware.Context, handler AddEndpointHandler) *AddEndpoint {
	return &AddEndpoint{Context: ctx, Handler: handler}
}

/*AddEndpoint swagger:route POST / endpoint addEndpoint

Add a new Endpoint

*/
type AddEndpoint struct {
	Context *middleware.Context
	Handler AddEndpointHandler
}

func (o *AddEndpoint) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewAddEndpointParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
