///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package endpoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// DeleteEndpointOKCode is the HTTP code returned for type DeleteEndpointOK
const DeleteEndpointOKCode int = 200

/*DeleteEndpointOK Successful operation

swagger:response deleteEndpointOK
*/
type DeleteEndpointOK struct {

	/*
	  In: Body
	*/
	Payload *v1.Endpoint `json:"body,omitempty"`
}

// NewDeleteEndpointOK creates DeleteEndpointOK with default headers values
func NewDeleteEndpointOK() *DeleteEndpointOK {

	return &DeleteEndpointOK{}
}

// WithPayload adds the payload to the delete endpoint o k response
func (o *DeleteEndpointOK) WithPayload(payload *v1.Endpoint) *DeleteEndpointOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete endpoint o k response
func (o *DeleteEndpointOK) SetPayload(payload *v1.Endpoint) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteEndpointOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteEndpointBadRequestCode is the HTTP code returned for type DeleteEndpointBadRequest
const DeleteEndpointBadRequestCode int = 400

/*DeleteEndpointBadRequest Invalid Name supplied

swagger:response deleteEndpointBadRequest
*/
type DeleteEndpointBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteEndpointBadRequest creates DeleteEndpointBadRequest with default headers values
func NewDeleteEndpointBadRequest() *DeleteEndpointBadRequest {

	return &DeleteEndpointBadRequest{}
}

// WithPayload adds the payload to the delete endpoint bad request response
func (o *DeleteEndpointBadRequest) WithPayload(payload *v1.Error) *DeleteEndpointBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete endpoint bad request response
func (o *DeleteEndpointBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteEndpointBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteEndpointUnauthorizedCode is the HTTP code returned for type DeleteEndpointUnauthorized
const DeleteEndpointUnauthorizedCode int = 401

/*DeleteEndpointUnauthorized Unauthorized Request

swagger:response deleteEndpointUnauthorized
*/
type DeleteEndpointUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteEndpointUnauthorized creates DeleteEndpointUnauthorized with default headers values
func NewDeleteEndpointUnauthorized() *DeleteEndpointUnauthorized {

	return &DeleteEndpointUnauthorized{}
}

// WithPayload adds the payload to the delete endpoint unauthorized response
func (o *DeleteEndpointUnauthorized) WithPayload(payload *v1.Error) *DeleteEndpointUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete endpoint unauthorized response
func (o *DeleteEndpointUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteEndpointUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteEndpointForbiddenCode is the HTTP code returned for type DeleteEndpointForbidden
const DeleteEndpointForbiddenCode int = 403

/*DeleteEndpointForbidden access to this resource is forbidden

swagger:response deleteEndpointForbidden
*/
type DeleteEndpointForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteEndpointForbidden creates DeleteEndpointForbidden with default headers values
func NewDeleteEndpointForbidden() *DeleteEndpointForbidden {

	return &DeleteEndpointForbidden{}
}

// WithPayload adds the payload to the delete endpoint forbidden response
func (o *DeleteEndpointForbidden) WithPayload(payload *v1.Error) *DeleteEndpointForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete endpoint forbidden response
func (o *DeleteEndpointForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteEndpointForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteEndpointNotFoundCode is the HTTP code returned for type DeleteEndpointNotFound
const DeleteEndpointNotFoundCode int = 404

/*DeleteEndpointNotFound Endpoint not found

swagger:response deleteEndpointNotFound
*/
type DeleteEndpointNotFound struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteEndpointNotFound creates DeleteEndpointNotFound with default headers values
func NewDeleteEndpointNotFound() *DeleteEndpointNotFound {

	return &DeleteEndpointNotFound{}
}

// WithPayload adds the payload to the delete endpoint not found response
func (o *DeleteEndpointNotFound) WithPayload(payload *v1.Error) *DeleteEndpointNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete endpoint not found response
func (o *DeleteEndpointNotFound) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteEndpointNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*DeleteEndpointDefault Unknown error

swagger:response deleteEndpointDefault
*/
type DeleteEndpointDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteEndpointDefault creates DeleteEndpointDefault with default headers values
func NewDeleteEndpointDefault(code int) *DeleteEndpointDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteEndpointDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete endpoint default response
func (o *DeleteEndpointDefault) WithStatusCode(code int) *DeleteEndpointDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete endpoint default response
func (o *DeleteEndpointDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the delete endpoint default response
func (o *DeleteEndpointDefault) WithPayload(payload *v1.Error) *DeleteEndpointDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete endpoint default response
func (o *DeleteEndpointDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteEndpointDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
