///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package endpoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// GetEndpointHandlerFunc turns a function with the right signature into a get endpoint handler
type GetEndpointHandlerFunc func(GetEndpointParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetEndpointHandlerFunc) Handle(params GetEndpointParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetEndpointHandler interface for that can handle valid get endpoint params
type GetEndpointHandler interface {
	Handle(GetEndpointParams, interface{}) middleware.Responder
}

// NewGetEndpoint creates a new http.Handler for the get endpoint operation
func NewGetEndpoint(ctx *middleware.Context, handler GetEndpointHandler) *GetEndpoint {
	return &GetEndpoint{Context: ctx, Handler: handler}
}

/*GetEndpoint swagger:route GET /{endpoint} endpoint getEndpoint

Find Endpoint by name

get an Endpoint by name

*/
type GetEndpoint struct {
	Context *middleware.Context
	Handler GetEndpointHandler
}

func (o *GetEndpoint) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetEndpointParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
