///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package endpoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// GetEndpointsHandlerFunc turns a function with the right signature into a get endpoints handler
type GetEndpointsHandlerFunc func(GetEndpointsParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetEndpointsHandlerFunc) Handle(params GetEndpointsParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetEndpointsHandler interface for that can handle valid get endpoints params
type GetEndpointsHandler interface {
	Handle(GetEndpointsParams, interface{}) middleware.Responder
}

// NewGetEndpoints creates a new http.Handler for the get endpoints operation
func NewGetEndpoints(ctx *middleware.Context, handler GetEndpointsHandler) *GetEndpoints {
	return &GetEndpoints{Context: ctx, Handler: handler}
}

/*GetEndpoints swagger:route GET / endpoint getEndpoints

List all existing Endpoints

*/
type GetEndpoints struct {
	Context *middleware.Context
	Handler GetEndpointsHandler
}

func (o *GetEndpoints) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetEndpointsParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
