///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package endpoint

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// UpdateEndpointHandlerFunc turns a function with the right signature into a update endpoint handler
type UpdateEndpointHandlerFunc func(UpdateEndpointParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn UpdateEndpointHandlerFunc) Handle(params UpdateEndpointParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// UpdateEndpointHandler interface for that can handle valid update endpoint params
type UpdateEndpointHandler interface {
	Handle(UpdateEndpointParams, interface{}) middleware.Responder
}

// NewUpdateEndpoint creates a new http.Handler for the update endpoint operation
func NewUpdateEndpoint(ctx *middleware.Context, handler UpdateEndpointHandler) *UpdateEndpoint {
	return &UpdateEndpoint{Context: ctx, Handler: handler}
}

/*UpdateEndpoint swagger:route PUT /{endpoint} endpoint updateEndpoint

Update an Endpoint

*/
type UpdateEndpoint struct {
	Context *middleware.Context
	Handler UpdateEndpointHandler
}

func (o *UpdateEndpoint) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUpdateEndpointParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
