///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// NewAddDriverTypeParams creates a new AddDriverTypeParams object
// with the default values initialized.
func NewAddDriverTypeParams() *AddDriverTypeParams {
	var ()
	return &AddDriverTypeParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewAddDriverTypeParamsWithTimeout creates a new AddDriverTypeParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewAddDriverTypeParamsWithTimeout(timeout time.Duration) *AddDriverTypeParams {
	var ()
	return &AddDriverTypeParams{

		timeout: timeout,
	}
}

// NewAddDriverTypeParamsWithContext creates a new AddDriverTypeParams object
// with the default values initialized, and the ability to set a context for a request
func NewAddDriverTypeParamsWithContext(ctx context.Context) *AddDriverTypeParams {
	var ()
	return &AddDriverTypeParams{

		Context: ctx,
	}
}

// NewAddDriverTypeParamsWithHTTPClient creates a new AddDriverTypeParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewAddDriverTypeParamsWithHTTPClient(client *http.Client) *AddDriverTypeParams {
	var ()
	return &AddDriverTypeParams{
		HTTPClient: client,
	}
}

/*AddDriverTypeParams contains all the parameters to send to the API endpoint
for the add driver type operation typically these are written to a http.Request
*/
type AddDriverTypeParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string
	/*Body
	  driver type object

	*/
	Body *v1.EventDriverType

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the add driver type params
func (o *AddDriverTypeParams) WithTimeout(timeout time.Duration) *AddDriverTypeParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add driver type params
func (o *AddDriverTypeParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add driver type params
func (o *AddDriverTypeParams) WithContext(ctx context.Context) *AddDriverTypeParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add driver type params
func (o *AddDriverTypeParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add driver type params
func (o *AddDriverTypeParams) WithHTTPClient(client *http.Client) *AddDriverTypeParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add driver type params
func (o *AddDriverTypeParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the add driver type params
func (o *AddDriverTypeParams) WithXDispatchOrg(xDispatchOrg string) *AddDriverTypeParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the add driver type params
func (o *AddDriverTypeParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithBody adds the body to the add driver type params
func (o *AddDriverTypeParams) WithBody(body *v1.EventDriverType) *AddDriverTypeParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add driver type params
func (o *AddDriverTypeParams) SetBody(body *v1.EventDriverType) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddDriverTypeParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
