///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// New creates a new drivers API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Client {
	return &Client{transport: transport, formats: formats}
}

/*
Client for drivers API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

/*
AddDriver creates a new driver
*/
func (a *Client) AddDriver(params *AddDriverParams, authInfo runtime.ClientAuthInfoWriter) (*AddDriverCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewAddDriverParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "addDriver",
		Method:             "POST",
		PathPattern:        "/drivers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &AddDriverReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*AddDriverCreated), nil

}

/*
AddDriverType creates a new driver type
*/
func (a *Client) AddDriverType(params *AddDriverTypeParams, authInfo runtime.ClientAuthInfoWriter) (*AddDriverTypeCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewAddDriverTypeParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "addDriverType",
		Method:             "POST",
		PathPattern:        "/drivertypes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &AddDriverTypeReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*AddDriverTypeCreated), nil

}

/*
DeleteDriver deletes a driver
*/
func (a *Client) DeleteDriver(params *DeleteDriverParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteDriverOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteDriverParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteDriver",
		Method:             "DELETE",
		PathPattern:        "/drivers/{driverName}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &DeleteDriverReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*DeleteDriverOK), nil

}

/*
DeleteDriverType deletes a driver type
*/
func (a *Client) DeleteDriverType(params *DeleteDriverTypeParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteDriverTypeOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteDriverTypeParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteDriverType",
		Method:             "DELETE",
		PathPattern:        "/drivertypes/{driverTypeName}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &DeleteDriverTypeReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*DeleteDriverTypeOK), nil

}

/*
GetDriver finds driver by name

Returns a single driver
*/
func (a *Client) GetDriver(params *GetDriverParams, authInfo runtime.ClientAuthInfoWriter) (*GetDriverOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetDriverParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getDriver",
		Method:             "GET",
		PathPattern:        "/drivers/{driverName}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetDriverReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetDriverOK), nil

}

/*
GetDriverType finds driver type by name

Returns a single driver type
*/
func (a *Client) GetDriverType(params *GetDriverTypeParams, authInfo runtime.ClientAuthInfoWriter) (*GetDriverTypeOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetDriverTypeParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getDriverType",
		Method:             "GET",
		PathPattern:        "/drivertypes/{driverTypeName}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetDriverTypeReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetDriverTypeOK), nil

}

/*
GetDriverTypes lists all existing driver types
*/
func (a *Client) GetDriverTypes(params *GetDriverTypesParams, authInfo runtime.ClientAuthInfoWriter) (*GetDriverTypesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetDriverTypesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getDriverTypes",
		Method:             "GET",
		PathPattern:        "/drivertypes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetDriverTypesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetDriverTypesOK), nil

}

/*
GetDrivers lists all existing drivers
*/
func (a *Client) GetDrivers(params *GetDriversParams, authInfo runtime.ClientAuthInfoWriter) (*GetDriversOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetDriversParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getDrivers",
		Method:             "GET",
		PathPattern:        "/drivers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetDriversReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetDriversOK), nil

}

/*
UpdateDriver updates driver by name

Updates a single driver
*/
func (a *Client) UpdateDriver(params *UpdateDriverParams, authInfo runtime.ClientAuthInfoWriter) (*UpdateDriverOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewUpdateDriverParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "updateDriver",
		Method:             "PUT",
		PathPattern:        "/drivers/{driverName}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &UpdateDriverReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*UpdateDriverOK), nil

}

/*
UpdateDriverType updates a driver type by name

Updates a single driver type
*/
func (a *Client) UpdateDriverType(params *UpdateDriverTypeParams, authInfo runtime.ClientAuthInfoWriter) (*UpdateDriverTypeOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewUpdateDriverTypeParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "updateDriverType",
		Method:             "PUT",
		PathPattern:        "/drivertypes/{driverTypeName}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &UpdateDriverTypeReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*UpdateDriverTypeOK), nil

}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
