///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// GetDriverReader is a Reader for the GetDriver structure.
type GetDriverReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDriverReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetDriverOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewGetDriverBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewGetDriverUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewGetDriverForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewGetDriverNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewGetDriverDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDriverOK creates a GetDriverOK with default headers values
func NewGetDriverOK() *GetDriverOK {
	return &GetDriverOK{}
}

/*GetDriverOK handles this case with default header values.

Successful operation
*/
type GetDriverOK struct {
	Payload *v1.EventDriver
}

func (o *GetDriverOK) Error() string {
	return fmt.Sprintf("[GET /drivers/{driverName}][%d] getDriverOK  %+v", 200, o.Payload)
}

func (o *GetDriverOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.EventDriver)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDriverBadRequest creates a GetDriverBadRequest with default headers values
func NewGetDriverBadRequest() *GetDriverBadRequest {
	return &GetDriverBadRequest{}
}

/*GetDriverBadRequest handles this case with default header values.

Invalid Name supplied
*/
type GetDriverBadRequest struct {
	Payload *v1.Error
}

func (o *GetDriverBadRequest) Error() string {
	return fmt.Sprintf("[GET /drivers/{driverName}][%d] getDriverBadRequest  %+v", 400, o.Payload)
}

func (o *GetDriverBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDriverUnauthorized creates a GetDriverUnauthorized with default headers values
func NewGetDriverUnauthorized() *GetDriverUnauthorized {
	return &GetDriverUnauthorized{}
}

/*GetDriverUnauthorized handles this case with default header values.

Unauthorized Request
*/
type GetDriverUnauthorized struct {
	Payload *v1.Error
}

func (o *GetDriverUnauthorized) Error() string {
	return fmt.Sprintf("[GET /drivers/{driverName}][%d] getDriverUnauthorized  %+v", 401, o.Payload)
}

func (o *GetDriverUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDriverForbidden creates a GetDriverForbidden with default headers values
func NewGetDriverForbidden() *GetDriverForbidden {
	return &GetDriverForbidden{}
}

/*GetDriverForbidden handles this case with default header values.

access to this resource is forbidden
*/
type GetDriverForbidden struct {
	Payload *v1.Error
}

func (o *GetDriverForbidden) Error() string {
	return fmt.Sprintf("[GET /drivers/{driverName}][%d] getDriverForbidden  %+v", 403, o.Payload)
}

func (o *GetDriverForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDriverNotFound creates a GetDriverNotFound with default headers values
func NewGetDriverNotFound() *GetDriverNotFound {
	return &GetDriverNotFound{}
}

/*GetDriverNotFound handles this case with default header values.

Driver not found
*/
type GetDriverNotFound struct {
	Payload *v1.Error
}

func (o *GetDriverNotFound) Error() string {
	return fmt.Sprintf("[GET /drivers/{driverName}][%d] getDriverNotFound  %+v", 404, o.Payload)
}

func (o *GetDriverNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDriverDefault creates a GetDriverDefault with default headers values
func NewGetDriverDefault(code int) *GetDriverDefault {
	return &GetDriverDefault{
		_statusCode: code,
	}
}

/*GetDriverDefault handles this case with default header values.

Unknown error
*/
type GetDriverDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the get driver default response
func (o *GetDriverDefault) Code() int {
	return o._statusCode
}

func (o *GetDriverDefault) Error() string {
	return fmt.Sprintf("[GET /drivers/{driverName}][%d] getDriver default  %+v", o._statusCode, o.Payload)
}

func (o *GetDriverDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
