///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetDriverTypeParams creates a new GetDriverTypeParams object
// with the default values initialized.
func NewGetDriverTypeParams() *GetDriverTypeParams {
	var ()
	return &GetDriverTypeParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetDriverTypeParamsWithTimeout creates a new GetDriverTypeParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetDriverTypeParamsWithTimeout(timeout time.Duration) *GetDriverTypeParams {
	var ()
	return &GetDriverTypeParams{

		timeout: timeout,
	}
}

// NewGetDriverTypeParamsWithContext creates a new GetDriverTypeParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetDriverTypeParamsWithContext(ctx context.Context) *GetDriverTypeParams {
	var ()
	return &GetDriverTypeParams{

		Context: ctx,
	}
}

// NewGetDriverTypeParamsWithHTTPClient creates a new GetDriverTypeParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetDriverTypeParamsWithHTTPClient(client *http.Client) *GetDriverTypeParams {
	var ()
	return &GetDriverTypeParams{
		HTTPClient: client,
	}
}

/*GetDriverTypeParams contains all the parameters to send to the API endpoint
for the get driver type operation typically these are written to a http.Request
*/
type GetDriverTypeParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string
	/*DriverTypeName
	  Name of the driver type to work on

	*/
	DriverTypeName string
	/*Tags
	  Filter based on tags

	*/
	Tags []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get driver type params
func (o *GetDriverTypeParams) WithTimeout(timeout time.Duration) *GetDriverTypeParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get driver type params
func (o *GetDriverTypeParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get driver type params
func (o *GetDriverTypeParams) WithContext(ctx context.Context) *GetDriverTypeParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get driver type params
func (o *GetDriverTypeParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get driver type params
func (o *GetDriverTypeParams) WithHTTPClient(client *http.Client) *GetDriverTypeParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get driver type params
func (o *GetDriverTypeParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the get driver type params
func (o *GetDriverTypeParams) WithXDispatchOrg(xDispatchOrg string) *GetDriverTypeParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the get driver type params
func (o *GetDriverTypeParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithDriverTypeName adds the driverTypeName to the get driver type params
func (o *GetDriverTypeParams) WithDriverTypeName(driverTypeName string) *GetDriverTypeParams {
	o.SetDriverTypeName(driverTypeName)
	return o
}

// SetDriverTypeName adds the driverTypeName to the get driver type params
func (o *GetDriverTypeParams) SetDriverTypeName(driverTypeName string) {
	o.DriverTypeName = driverTypeName
}

// WithTags adds the tags to the get driver type params
func (o *GetDriverTypeParams) WithTags(tags []string) *GetDriverTypeParams {
	o.SetTags(tags)
	return o
}

// SetTags adds the tags to the get driver type params
func (o *GetDriverTypeParams) SetTags(tags []string) {
	o.Tags = tags
}

// WriteToRequest writes these params to a swagger request
func (o *GetDriverTypeParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	// path param driverTypeName
	if err := r.SetPathParam("driverTypeName", o.DriverTypeName); err != nil {
		return err
	}

	valuesTags := o.Tags

	joinedTags := swag.JoinByFormat(valuesTags, "multi")
	// query array param tags
	if err := r.SetQueryParam("tags", joinedTags...); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
