///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// NewUpdateDriverParams creates a new UpdateDriverParams object
// with the default values initialized.
func NewUpdateDriverParams() *UpdateDriverParams {
	var ()
	return &UpdateDriverParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateDriverParamsWithTimeout creates a new UpdateDriverParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewUpdateDriverParamsWithTimeout(timeout time.Duration) *UpdateDriverParams {
	var ()
	return &UpdateDriverParams{

		timeout: timeout,
	}
}

// NewUpdateDriverParamsWithContext creates a new UpdateDriverParams object
// with the default values initialized, and the ability to set a context for a request
func NewUpdateDriverParamsWithContext(ctx context.Context) *UpdateDriverParams {
	var ()
	return &UpdateDriverParams{

		Context: ctx,
	}
}

// NewUpdateDriverParamsWithHTTPClient creates a new UpdateDriverParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewUpdateDriverParamsWithHTTPClient(client *http.Client) *UpdateDriverParams {
	var ()
	return &UpdateDriverParams{
		HTTPClient: client,
	}
}

/*UpdateDriverParams contains all the parameters to send to the API endpoint
for the update driver operation typically these are written to a http.Request
*/
type UpdateDriverParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string
	/*Body
	  driver object

	*/
	Body *v1.EventDriver
	/*DriverName
	  Name of the driver to work on

	*/
	DriverName string
	/*Tags
	  Filter based on tags

	*/
	Tags []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the update driver params
func (o *UpdateDriverParams) WithTimeout(timeout time.Duration) *UpdateDriverParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update driver params
func (o *UpdateDriverParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update driver params
func (o *UpdateDriverParams) WithContext(ctx context.Context) *UpdateDriverParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update driver params
func (o *UpdateDriverParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update driver params
func (o *UpdateDriverParams) WithHTTPClient(client *http.Client) *UpdateDriverParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update driver params
func (o *UpdateDriverParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the update driver params
func (o *UpdateDriverParams) WithXDispatchOrg(xDispatchOrg string) *UpdateDriverParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the update driver params
func (o *UpdateDriverParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithBody adds the body to the update driver params
func (o *UpdateDriverParams) WithBody(body *v1.EventDriver) *UpdateDriverParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update driver params
func (o *UpdateDriverParams) SetBody(body *v1.EventDriver) {
	o.Body = body
}

// WithDriverName adds the driverName to the update driver params
func (o *UpdateDriverParams) WithDriverName(driverName string) *UpdateDriverParams {
	o.SetDriverName(driverName)
	return o
}

// SetDriverName adds the driverName to the update driver params
func (o *UpdateDriverParams) SetDriverName(driverName string) {
	o.DriverName = driverName
}

// WithTags adds the tags to the update driver params
func (o *UpdateDriverParams) WithTags(tags []string) *UpdateDriverParams {
	o.SetTags(tags)
	return o
}

// SetTags adds the tags to the update driver params
func (o *UpdateDriverParams) SetTags(tags []string) {
	o.Tags = tags
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateDriverParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param driverName
	if err := r.SetPathParam("driverName", o.DriverName); err != nil {
		return err
	}

	valuesTags := o.Tags

	joinedTags := swag.JoinByFormat(valuesTags, "multi")
	// query array param tags
	if err := r.SetQueryParam("tags", joinedTags...); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
