///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package events

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// NewEmitEventParams creates a new EmitEventParams object
// with the default values initialized.
func NewEmitEventParams() *EmitEventParams {
	var ()
	return &EmitEventParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewEmitEventParamsWithTimeout creates a new EmitEventParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewEmitEventParamsWithTimeout(timeout time.Duration) *EmitEventParams {
	var ()
	return &EmitEventParams{

		timeout: timeout,
	}
}

// NewEmitEventParamsWithContext creates a new EmitEventParams object
// with the default values initialized, and the ability to set a context for a request
func NewEmitEventParamsWithContext(ctx context.Context) *EmitEventParams {
	var ()
	return &EmitEventParams{

		Context: ctx,
	}
}

// NewEmitEventParamsWithHTTPClient creates a new EmitEventParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewEmitEventParamsWithHTTPClient(client *http.Client) *EmitEventParams {
	var ()
	return &EmitEventParams{
		HTTPClient: client,
	}
}

/*EmitEventParams contains all the parameters to send to the API endpoint
for the emit event operation typically these are written to a http.Request
*/
type EmitEventParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string
	/*Body
	  emission object

	*/
	Body *v1.Emission

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the emit event params
func (o *EmitEventParams) WithTimeout(timeout time.Duration) *EmitEventParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the emit event params
func (o *EmitEventParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the emit event params
func (o *EmitEventParams) WithContext(ctx context.Context) *EmitEventParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the emit event params
func (o *EmitEventParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the emit event params
func (o *EmitEventParams) WithHTTPClient(client *http.Client) *EmitEventParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the emit event params
func (o *EmitEventParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the emit event params
func (o *EmitEventParams) WithXDispatchOrg(xDispatchOrg string) *EmitEventParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the emit event params
func (o *EmitEventParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithBody adds the body to the emit event params
func (o *EmitEventParams) WithBody(body *v1.Emission) *EmitEventParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the emit event params
func (o *EmitEventParams) SetBody(body *v1.Emission) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *EmitEventParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
