///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// DeleteSubscriptionReader is a Reader for the DeleteSubscription structure.
type DeleteSubscriptionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteSubscriptionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewDeleteSubscriptionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewDeleteSubscriptionBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewDeleteSubscriptionUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewDeleteSubscriptionForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewDeleteSubscriptionNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewDeleteSubscriptionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteSubscriptionOK creates a DeleteSubscriptionOK with default headers values
func NewDeleteSubscriptionOK() *DeleteSubscriptionOK {
	return &DeleteSubscriptionOK{}
}

/*DeleteSubscriptionOK handles this case with default header values.

successful operation
*/
type DeleteSubscriptionOK struct {
	Payload *v1.Subscription
}

func (o *DeleteSubscriptionOK) Error() string {
	return fmt.Sprintf("[DELETE /subscriptions/{subscriptionName}][%d] deleteSubscriptionOK  %+v", 200, o.Payload)
}

func (o *DeleteSubscriptionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Subscription)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSubscriptionBadRequest creates a DeleteSubscriptionBadRequest with default headers values
func NewDeleteSubscriptionBadRequest() *DeleteSubscriptionBadRequest {
	return &DeleteSubscriptionBadRequest{}
}

/*DeleteSubscriptionBadRequest handles this case with default header values.

Invalid ID supplied
*/
type DeleteSubscriptionBadRequest struct {
	Payload *v1.Error
}

func (o *DeleteSubscriptionBadRequest) Error() string {
	return fmt.Sprintf("[DELETE /subscriptions/{subscriptionName}][%d] deleteSubscriptionBadRequest  %+v", 400, o.Payload)
}

func (o *DeleteSubscriptionBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSubscriptionUnauthorized creates a DeleteSubscriptionUnauthorized with default headers values
func NewDeleteSubscriptionUnauthorized() *DeleteSubscriptionUnauthorized {
	return &DeleteSubscriptionUnauthorized{}
}

/*DeleteSubscriptionUnauthorized handles this case with default header values.

Unauthorized Request
*/
type DeleteSubscriptionUnauthorized struct {
	Payload *v1.Error
}

func (o *DeleteSubscriptionUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /subscriptions/{subscriptionName}][%d] deleteSubscriptionUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteSubscriptionUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSubscriptionForbidden creates a DeleteSubscriptionForbidden with default headers values
func NewDeleteSubscriptionForbidden() *DeleteSubscriptionForbidden {
	return &DeleteSubscriptionForbidden{}
}

/*DeleteSubscriptionForbidden handles this case with default header values.

access to this resource is forbidden
*/
type DeleteSubscriptionForbidden struct {
	Payload *v1.Error
}

func (o *DeleteSubscriptionForbidden) Error() string {
	return fmt.Sprintf("[DELETE /subscriptions/{subscriptionName}][%d] deleteSubscriptionForbidden  %+v", 403, o.Payload)
}

func (o *DeleteSubscriptionForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSubscriptionNotFound creates a DeleteSubscriptionNotFound with default headers values
func NewDeleteSubscriptionNotFound() *DeleteSubscriptionNotFound {
	return &DeleteSubscriptionNotFound{}
}

/*DeleteSubscriptionNotFound handles this case with default header values.

Subscription not found
*/
type DeleteSubscriptionNotFound struct {
	Payload *v1.Error
}

func (o *DeleteSubscriptionNotFound) Error() string {
	return fmt.Sprintf("[DELETE /subscriptions/{subscriptionName}][%d] deleteSubscriptionNotFound  %+v", 404, o.Payload)
}

func (o *DeleteSubscriptionNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSubscriptionDefault creates a DeleteSubscriptionDefault with default headers values
func NewDeleteSubscriptionDefault(code int) *DeleteSubscriptionDefault {
	return &DeleteSubscriptionDefault{
		_statusCode: code,
	}
}

/*DeleteSubscriptionDefault handles this case with default header values.

Generic error response
*/
type DeleteSubscriptionDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the delete subscription default response
func (o *DeleteSubscriptionDefault) Code() int {
	return o._statusCode
}

func (o *DeleteSubscriptionDefault) Error() string {
	return fmt.Sprintf("[DELETE /subscriptions/{subscriptionName}][%d] deleteSubscription default  %+v", o._statusCode, o.Payload)
}

func (o *DeleteSubscriptionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
