///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetSubscriptionParams creates a new GetSubscriptionParams object
// with the default values initialized.
func NewGetSubscriptionParams() *GetSubscriptionParams {
	var ()
	return &GetSubscriptionParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetSubscriptionParamsWithTimeout creates a new GetSubscriptionParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetSubscriptionParamsWithTimeout(timeout time.Duration) *GetSubscriptionParams {
	var ()
	return &GetSubscriptionParams{

		timeout: timeout,
	}
}

// NewGetSubscriptionParamsWithContext creates a new GetSubscriptionParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetSubscriptionParamsWithContext(ctx context.Context) *GetSubscriptionParams {
	var ()
	return &GetSubscriptionParams{

		Context: ctx,
	}
}

// NewGetSubscriptionParamsWithHTTPClient creates a new GetSubscriptionParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetSubscriptionParamsWithHTTPClient(client *http.Client) *GetSubscriptionParams {
	var ()
	return &GetSubscriptionParams{
		HTTPClient: client,
	}
}

/*GetSubscriptionParams contains all the parameters to send to the API endpoint
for the get subscription operation typically these are written to a http.Request
*/
type GetSubscriptionParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string
	/*SubscriptionName
	  Name of the subscription to work on

	*/
	SubscriptionName string
	/*Tags
	  Filter based on tags

	*/
	Tags []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get subscription params
func (o *GetSubscriptionParams) WithTimeout(timeout time.Duration) *GetSubscriptionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get subscription params
func (o *GetSubscriptionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get subscription params
func (o *GetSubscriptionParams) WithContext(ctx context.Context) *GetSubscriptionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get subscription params
func (o *GetSubscriptionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get subscription params
func (o *GetSubscriptionParams) WithHTTPClient(client *http.Client) *GetSubscriptionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get subscription params
func (o *GetSubscriptionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the get subscription params
func (o *GetSubscriptionParams) WithXDispatchOrg(xDispatchOrg string) *GetSubscriptionParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the get subscription params
func (o *GetSubscriptionParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithSubscriptionName adds the subscriptionName to the get subscription params
func (o *GetSubscriptionParams) WithSubscriptionName(subscriptionName string) *GetSubscriptionParams {
	o.SetSubscriptionName(subscriptionName)
	return o
}

// SetSubscriptionName adds the subscriptionName to the get subscription params
func (o *GetSubscriptionParams) SetSubscriptionName(subscriptionName string) {
	o.SubscriptionName = subscriptionName
}

// WithTags adds the tags to the get subscription params
func (o *GetSubscriptionParams) WithTags(tags []string) *GetSubscriptionParams {
	o.SetTags(tags)
	return o
}

// SetTags adds the tags to the get subscription params
func (o *GetSubscriptionParams) SetTags(tags []string) {
	o.Tags = tags
}

// WriteToRequest writes these params to a swagger request
func (o *GetSubscriptionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	// path param subscriptionName
	if err := r.SetPathParam("subscriptionName", o.SubscriptionName); err != nil {
		return err
	}

	valuesTags := o.Tags

	joinedTags := swag.JoinByFormat(valuesTags, "multi")
	// query array param tags
	if err := r.SetQueryParam("tags", joinedTags...); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
