///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// NewUpdateSubscriptionParams creates a new UpdateSubscriptionParams object
// with the default values initialized.
func NewUpdateSubscriptionParams() *UpdateSubscriptionParams {
	var ()
	return &UpdateSubscriptionParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateSubscriptionParamsWithTimeout creates a new UpdateSubscriptionParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewUpdateSubscriptionParamsWithTimeout(timeout time.Duration) *UpdateSubscriptionParams {
	var ()
	return &UpdateSubscriptionParams{

		timeout: timeout,
	}
}

// NewUpdateSubscriptionParamsWithContext creates a new UpdateSubscriptionParams object
// with the default values initialized, and the ability to set a context for a request
func NewUpdateSubscriptionParamsWithContext(ctx context.Context) *UpdateSubscriptionParams {
	var ()
	return &UpdateSubscriptionParams{

		Context: ctx,
	}
}

// NewUpdateSubscriptionParamsWithHTTPClient creates a new UpdateSubscriptionParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewUpdateSubscriptionParamsWithHTTPClient(client *http.Client) *UpdateSubscriptionParams {
	var ()
	return &UpdateSubscriptionParams{
		HTTPClient: client,
	}
}

/*UpdateSubscriptionParams contains all the parameters to send to the API endpoint
for the update subscription operation typically these are written to a http.Request
*/
type UpdateSubscriptionParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string
	/*Body
	  subscription object

	*/
	Body *v1.Subscription
	/*SubscriptionName
	  Name of the subscription to work on

	*/
	SubscriptionName string
	/*Tags
	  Filter based on tags

	*/
	Tags []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the update subscription params
func (o *UpdateSubscriptionParams) WithTimeout(timeout time.Duration) *UpdateSubscriptionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update subscription params
func (o *UpdateSubscriptionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update subscription params
func (o *UpdateSubscriptionParams) WithContext(ctx context.Context) *UpdateSubscriptionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update subscription params
func (o *UpdateSubscriptionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update subscription params
func (o *UpdateSubscriptionParams) WithHTTPClient(client *http.Client) *UpdateSubscriptionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update subscription params
func (o *UpdateSubscriptionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the update subscription params
func (o *UpdateSubscriptionParams) WithXDispatchOrg(xDispatchOrg string) *UpdateSubscriptionParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the update subscription params
func (o *UpdateSubscriptionParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithBody adds the body to the update subscription params
func (o *UpdateSubscriptionParams) WithBody(body *v1.Subscription) *UpdateSubscriptionParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update subscription params
func (o *UpdateSubscriptionParams) SetBody(body *v1.Subscription) {
	o.Body = body
}

// WithSubscriptionName adds the subscriptionName to the update subscription params
func (o *UpdateSubscriptionParams) WithSubscriptionName(subscriptionName string) *UpdateSubscriptionParams {
	o.SetSubscriptionName(subscriptionName)
	return o
}

// SetSubscriptionName adds the subscriptionName to the update subscription params
func (o *UpdateSubscriptionParams) SetSubscriptionName(subscriptionName string) {
	o.SubscriptionName = subscriptionName
}

// WithTags adds the tags to the update subscription params
func (o *UpdateSubscriptionParams) WithTags(tags []string) *UpdateSubscriptionParams {
	o.SetTags(tags)
	return o
}

// SetTags adds the tags to the update subscription params
func (o *UpdateSubscriptionParams) SetTags(tags []string) {
	o.Tags = tags
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateSubscriptionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param subscriptionName
	if err := r.SetPathParam("subscriptionName", o.SubscriptionName); err != nil {
		return err
	}

	valuesTags := o.Tags

	joinedTags := swag.JoinByFormat(valuesTags, "multi")
	// query array param tags
	if err := r.SetQueryParam("tags", joinedTags...); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
