///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// UpdateSubscriptionReader is a Reader for the UpdateSubscription structure.
type UpdateSubscriptionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateSubscriptionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewUpdateSubscriptionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewUpdateSubscriptionBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewUpdateSubscriptionUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewUpdateSubscriptionForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewUpdateSubscriptionNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewUpdateSubscriptionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateSubscriptionOK creates a UpdateSubscriptionOK with default headers values
func NewUpdateSubscriptionOK() *UpdateSubscriptionOK {
	return &UpdateSubscriptionOK{}
}

/*UpdateSubscriptionOK handles this case with default header values.

Successful operation
*/
type UpdateSubscriptionOK struct {
	Payload *v1.Subscription
}

func (o *UpdateSubscriptionOK) Error() string {
	return fmt.Sprintf("[PUT /subscriptions/{subscriptionName}][%d] updateSubscriptionOK  %+v", 200, o.Payload)
}

func (o *UpdateSubscriptionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Subscription)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateSubscriptionBadRequest creates a UpdateSubscriptionBadRequest with default headers values
func NewUpdateSubscriptionBadRequest() *UpdateSubscriptionBadRequest {
	return &UpdateSubscriptionBadRequest{}
}

/*UpdateSubscriptionBadRequest handles this case with default header values.

Invalid Name supplied
*/
type UpdateSubscriptionBadRequest struct {
	Payload *v1.Error
}

func (o *UpdateSubscriptionBadRequest) Error() string {
	return fmt.Sprintf("[PUT /subscriptions/{subscriptionName}][%d] updateSubscriptionBadRequest  %+v", 400, o.Payload)
}

func (o *UpdateSubscriptionBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateSubscriptionUnauthorized creates a UpdateSubscriptionUnauthorized with default headers values
func NewUpdateSubscriptionUnauthorized() *UpdateSubscriptionUnauthorized {
	return &UpdateSubscriptionUnauthorized{}
}

/*UpdateSubscriptionUnauthorized handles this case with default header values.

Unauthorized Request
*/
type UpdateSubscriptionUnauthorized struct {
	Payload *v1.Error
}

func (o *UpdateSubscriptionUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /subscriptions/{subscriptionName}][%d] updateSubscriptionUnauthorized  %+v", 401, o.Payload)
}

func (o *UpdateSubscriptionUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateSubscriptionForbidden creates a UpdateSubscriptionForbidden with default headers values
func NewUpdateSubscriptionForbidden() *UpdateSubscriptionForbidden {
	return &UpdateSubscriptionForbidden{}
}

/*UpdateSubscriptionForbidden handles this case with default header values.

access to this resource is forbidden
*/
type UpdateSubscriptionForbidden struct {
	Payload *v1.Error
}

func (o *UpdateSubscriptionForbidden) Error() string {
	return fmt.Sprintf("[PUT /subscriptions/{subscriptionName}][%d] updateSubscriptionForbidden  %+v", 403, o.Payload)
}

func (o *UpdateSubscriptionForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateSubscriptionNotFound creates a UpdateSubscriptionNotFound with default headers values
func NewUpdateSubscriptionNotFound() *UpdateSubscriptionNotFound {
	return &UpdateSubscriptionNotFound{}
}

/*UpdateSubscriptionNotFound handles this case with default header values.

Subscription not found
*/
type UpdateSubscriptionNotFound struct {
	Payload *v1.Error
}

func (o *UpdateSubscriptionNotFound) Error() string {
	return fmt.Sprintf("[PUT /subscriptions/{subscriptionName}][%d] updateSubscriptionNotFound  %+v", 404, o.Payload)
}

func (o *UpdateSubscriptionNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateSubscriptionDefault creates a UpdateSubscriptionDefault with default headers values
func NewUpdateSubscriptionDefault(code int) *UpdateSubscriptionDefault {
	return &UpdateSubscriptionDefault{
		_statusCode: code,
	}
}

/*UpdateSubscriptionDefault handles this case with default header values.

Unknown error
*/
type UpdateSubscriptionDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the update subscription default response
func (o *UpdateSubscriptionDefault) Code() int {
	return o._statusCode
}

func (o *UpdateSubscriptionDefault) Error() string {
	return fmt.Sprintf("[PUT /subscriptions/{subscriptionName}][%d] updateSubscription default  %+v", o._statusCode, o.Payload)
}

func (o *UpdateSubscriptionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
