///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// AddDriverHandlerFunc turns a function with the right signature into a add driver handler
type AddDriverHandlerFunc func(AddDriverParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn AddDriverHandlerFunc) Handle(params AddDriverParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// AddDriverHandler interface for that can handle valid add driver params
type AddDriverHandler interface {
	Handle(AddDriverParams, interface{}) middleware.Responder
}

// NewAddDriver creates a new http.Handler for the add driver operation
func NewAddDriver(ctx *middleware.Context, handler AddDriverHandler) *AddDriver {
	return &AddDriver{Context: ctx, Handler: handler}
}

/*AddDriver swagger:route POST /drivers drivers addDriver

Create a new driver

*/
type AddDriver struct {
	Context *middleware.Context
	Handler AddDriverHandler
}

func (o *AddDriver) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewAddDriverParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
