///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// AddDriverTypeHandlerFunc turns a function with the right signature into a add driver type handler
type AddDriverTypeHandlerFunc func(AddDriverTypeParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn AddDriverTypeHandlerFunc) Handle(params AddDriverTypeParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// AddDriverTypeHandler interface for that can handle valid add driver type params
type AddDriverTypeHandler interface {
	Handle(AddDriverTypeParams, interface{}) middleware.Responder
}

// NewAddDriverType creates a new http.Handler for the add driver type operation
func NewAddDriverType(ctx *middleware.Context, handler AddDriverTypeHandler) *AddDriverType {
	return &AddDriverType{Context: ctx, Handler: handler}
}

/*AddDriverType swagger:route POST /drivertypes drivers addDriverType

Create a new driver type

*/
type AddDriverType struct {
	Context *middleware.Context
	Handler AddDriverTypeHandler
}

func (o *AddDriverType) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewAddDriverTypeParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
