///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// DeleteDriverHandlerFunc turns a function with the right signature into a delete driver handler
type DeleteDriverHandlerFunc func(DeleteDriverParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn DeleteDriverHandlerFunc) Handle(params DeleteDriverParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// DeleteDriverHandler interface for that can handle valid delete driver params
type DeleteDriverHandler interface {
	Handle(DeleteDriverParams, interface{}) middleware.Responder
}

// NewDeleteDriver creates a new http.Handler for the delete driver operation
func NewDeleteDriver(ctx *middleware.Context, handler DeleteDriverHandler) *DeleteDriver {
	return &DeleteDriver{Context: ctx, Handler: handler}
}

/*DeleteDriver swagger:route DELETE /drivers/{driverName} drivers deleteDriver

Deletes a driver

*/
type DeleteDriver struct {
	Context *middleware.Context
	Handler DeleteDriverHandler
}

func (o *DeleteDriver) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewDeleteDriverParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
