///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// DeleteDriverOKCode is the HTTP code returned for type DeleteDriverOK
const DeleteDriverOKCode int = 200

/*DeleteDriverOK successful operation

swagger:response deleteDriverOK
*/
type DeleteDriverOK struct {

	/*
	  In: Body
	*/
	Payload *v1.EventDriver `json:"body,omitempty"`
}

// NewDeleteDriverOK creates DeleteDriverOK with default headers values
func NewDeleteDriverOK() *DeleteDriverOK {

	return &DeleteDriverOK{}
}

// WithPayload adds the payload to the delete driver o k response
func (o *DeleteDriverOK) WithPayload(payload *v1.EventDriver) *DeleteDriverOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver o k response
func (o *DeleteDriverOK) SetPayload(payload *v1.EventDriver) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteDriverBadRequestCode is the HTTP code returned for type DeleteDriverBadRequest
const DeleteDriverBadRequestCode int = 400

/*DeleteDriverBadRequest Invalid ID supplied

swagger:response deleteDriverBadRequest
*/
type DeleteDriverBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverBadRequest creates DeleteDriverBadRequest with default headers values
func NewDeleteDriverBadRequest() *DeleteDriverBadRequest {

	return &DeleteDriverBadRequest{}
}

// WithPayload adds the payload to the delete driver bad request response
func (o *DeleteDriverBadRequest) WithPayload(payload *v1.Error) *DeleteDriverBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver bad request response
func (o *DeleteDriverBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteDriverUnauthorizedCode is the HTTP code returned for type DeleteDriverUnauthorized
const DeleteDriverUnauthorizedCode int = 401

/*DeleteDriverUnauthorized Unauthorized Request

swagger:response deleteDriverUnauthorized
*/
type DeleteDriverUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverUnauthorized creates DeleteDriverUnauthorized with default headers values
func NewDeleteDriverUnauthorized() *DeleteDriverUnauthorized {

	return &DeleteDriverUnauthorized{}
}

// WithPayload adds the payload to the delete driver unauthorized response
func (o *DeleteDriverUnauthorized) WithPayload(payload *v1.Error) *DeleteDriverUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver unauthorized response
func (o *DeleteDriverUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteDriverForbiddenCode is the HTTP code returned for type DeleteDriverForbidden
const DeleteDriverForbiddenCode int = 403

/*DeleteDriverForbidden access to this resource is forbidden

swagger:response deleteDriverForbidden
*/
type DeleteDriverForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverForbidden creates DeleteDriverForbidden with default headers values
func NewDeleteDriverForbidden() *DeleteDriverForbidden {

	return &DeleteDriverForbidden{}
}

// WithPayload adds the payload to the delete driver forbidden response
func (o *DeleteDriverForbidden) WithPayload(payload *v1.Error) *DeleteDriverForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver forbidden response
func (o *DeleteDriverForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteDriverNotFoundCode is the HTTP code returned for type DeleteDriverNotFound
const DeleteDriverNotFoundCode int = 404

/*DeleteDriverNotFound Driver not found

swagger:response deleteDriverNotFound
*/
type DeleteDriverNotFound struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverNotFound creates DeleteDriverNotFound with default headers values
func NewDeleteDriverNotFound() *DeleteDriverNotFound {

	return &DeleteDriverNotFound{}
}

// WithPayload adds the payload to the delete driver not found response
func (o *DeleteDriverNotFound) WithPayload(payload *v1.Error) *DeleteDriverNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver not found response
func (o *DeleteDriverNotFound) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*DeleteDriverDefault Generic error response

swagger:response deleteDriverDefault
*/
type DeleteDriverDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverDefault creates DeleteDriverDefault with default headers values
func NewDeleteDriverDefault(code int) *DeleteDriverDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteDriverDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete driver default response
func (o *DeleteDriverDefault) WithStatusCode(code int) *DeleteDriverDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete driver default response
func (o *DeleteDriverDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the delete driver default response
func (o *DeleteDriverDefault) WithPayload(payload *v1.Error) *DeleteDriverDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver default response
func (o *DeleteDriverDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
