///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// DeleteDriverTypeHandlerFunc turns a function with the right signature into a delete driver type handler
type DeleteDriverTypeHandlerFunc func(DeleteDriverTypeParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn DeleteDriverTypeHandlerFunc) Handle(params DeleteDriverTypeParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// DeleteDriverTypeHandler interface for that can handle valid delete driver type params
type DeleteDriverTypeHandler interface {
	Handle(DeleteDriverTypeParams, interface{}) middleware.Responder
}

// NewDeleteDriverType creates a new http.Handler for the delete driver type operation
func NewDeleteDriverType(ctx *middleware.Context, handler DeleteDriverTypeHandler) *DeleteDriverType {
	return &DeleteDriverType{Context: ctx, Handler: handler}
}

/*DeleteDriverType swagger:route DELETE /drivertypes/{driverTypeName} drivers deleteDriverType

Deletes a driver type

*/
type DeleteDriverType struct {
	Context *middleware.Context
	Handler DeleteDriverTypeHandler
}

func (o *DeleteDriverType) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewDeleteDriverTypeParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
