///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// DeleteDriverTypeOKCode is the HTTP code returned for type DeleteDriverTypeOK
const DeleteDriverTypeOKCode int = 200

/*DeleteDriverTypeOK successful operation

swagger:response deleteDriverTypeOK
*/
type DeleteDriverTypeOK struct {

	/*
	  In: Body
	*/
	Payload *v1.EventDriverType `json:"body,omitempty"`
}

// NewDeleteDriverTypeOK creates DeleteDriverTypeOK with default headers values
func NewDeleteDriverTypeOK() *DeleteDriverTypeOK {

	return &DeleteDriverTypeOK{}
}

// WithPayload adds the payload to the delete driver type o k response
func (o *DeleteDriverTypeOK) WithPayload(payload *v1.EventDriverType) *DeleteDriverTypeOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver type o k response
func (o *DeleteDriverTypeOK) SetPayload(payload *v1.EventDriverType) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverTypeOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteDriverTypeBadRequestCode is the HTTP code returned for type DeleteDriverTypeBadRequest
const DeleteDriverTypeBadRequestCode int = 400

/*DeleteDriverTypeBadRequest Invalid ID supplied

swagger:response deleteDriverTypeBadRequest
*/
type DeleteDriverTypeBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverTypeBadRequest creates DeleteDriverTypeBadRequest with default headers values
func NewDeleteDriverTypeBadRequest() *DeleteDriverTypeBadRequest {

	return &DeleteDriverTypeBadRequest{}
}

// WithPayload adds the payload to the delete driver type bad request response
func (o *DeleteDriverTypeBadRequest) WithPayload(payload *v1.Error) *DeleteDriverTypeBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver type bad request response
func (o *DeleteDriverTypeBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverTypeBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteDriverTypeUnauthorizedCode is the HTTP code returned for type DeleteDriverTypeUnauthorized
const DeleteDriverTypeUnauthorizedCode int = 401

/*DeleteDriverTypeUnauthorized Unauthorized Request

swagger:response deleteDriverTypeUnauthorized
*/
type DeleteDriverTypeUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverTypeUnauthorized creates DeleteDriverTypeUnauthorized with default headers values
func NewDeleteDriverTypeUnauthorized() *DeleteDriverTypeUnauthorized {

	return &DeleteDriverTypeUnauthorized{}
}

// WithPayload adds the payload to the delete driver type unauthorized response
func (o *DeleteDriverTypeUnauthorized) WithPayload(payload *v1.Error) *DeleteDriverTypeUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver type unauthorized response
func (o *DeleteDriverTypeUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverTypeUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteDriverTypeForbiddenCode is the HTTP code returned for type DeleteDriverTypeForbidden
const DeleteDriverTypeForbiddenCode int = 403

/*DeleteDriverTypeForbidden access to this resource is forbidden

swagger:response deleteDriverTypeForbidden
*/
type DeleteDriverTypeForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverTypeForbidden creates DeleteDriverTypeForbidden with default headers values
func NewDeleteDriverTypeForbidden() *DeleteDriverTypeForbidden {

	return &DeleteDriverTypeForbidden{}
}

// WithPayload adds the payload to the delete driver type forbidden response
func (o *DeleteDriverTypeForbidden) WithPayload(payload *v1.Error) *DeleteDriverTypeForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver type forbidden response
func (o *DeleteDriverTypeForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverTypeForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteDriverTypeNotFoundCode is the HTTP code returned for type DeleteDriverTypeNotFound
const DeleteDriverTypeNotFoundCode int = 404

/*DeleteDriverTypeNotFound Driver not found

swagger:response deleteDriverTypeNotFound
*/
type DeleteDriverTypeNotFound struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverTypeNotFound creates DeleteDriverTypeNotFound with default headers values
func NewDeleteDriverTypeNotFound() *DeleteDriverTypeNotFound {

	return &DeleteDriverTypeNotFound{}
}

// WithPayload adds the payload to the delete driver type not found response
func (o *DeleteDriverTypeNotFound) WithPayload(payload *v1.Error) *DeleteDriverTypeNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver type not found response
func (o *DeleteDriverTypeNotFound) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverTypeNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*DeleteDriverTypeDefault Generic error response

swagger:response deleteDriverTypeDefault
*/
type DeleteDriverTypeDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteDriverTypeDefault creates DeleteDriverTypeDefault with default headers values
func NewDeleteDriverTypeDefault(code int) *DeleteDriverTypeDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteDriverTypeDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete driver type default response
func (o *DeleteDriverTypeDefault) WithStatusCode(code int) *DeleteDriverTypeDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete driver type default response
func (o *DeleteDriverTypeDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the delete driver type default response
func (o *DeleteDriverTypeDefault) WithPayload(payload *v1.Error) *DeleteDriverTypeDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete driver type default response
func (o *DeleteDriverTypeDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteDriverTypeDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
