///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// UpdateDriverHandlerFunc turns a function with the right signature into a update driver handler
type UpdateDriverHandlerFunc func(UpdateDriverParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn UpdateDriverHandlerFunc) Handle(params UpdateDriverParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// UpdateDriverHandler interface for that can handle valid update driver params
type UpdateDriverHandler interface {
	Handle(UpdateDriverParams, interface{}) middleware.Responder
}

// NewUpdateDriver creates a new http.Handler for the update driver operation
func NewUpdateDriver(ctx *middleware.Context, handler UpdateDriverHandler) *UpdateDriver {
	return &UpdateDriver{Context: ctx, Handler: handler}
}

/*UpdateDriver swagger:route PUT /drivers/{driverName} drivers updateDriver

Update driver by Name

Updates a single driver

*/
type UpdateDriver struct {
	Context *middleware.Context
	Handler UpdateDriverHandler
}

func (o *UpdateDriver) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUpdateDriverParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
