///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package drivers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// UpdateDriverOKCode is the HTTP code returned for type UpdateDriverOK
const UpdateDriverOKCode int = 200

/*UpdateDriverOK Successful operation

swagger:response updateDriverOK
*/
type UpdateDriverOK struct {

	/*
	  In: Body
	*/
	Payload *v1.EventDriver `json:"body,omitempty"`
}

// NewUpdateDriverOK creates UpdateDriverOK with default headers values
func NewUpdateDriverOK() *UpdateDriverOK {

	return &UpdateDriverOK{}
}

// WithPayload adds the payload to the update driver o k response
func (o *UpdateDriverOK) WithPayload(payload *v1.EventDriver) *UpdateDriverOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the update driver o k response
func (o *UpdateDriverOK) SetPayload(payload *v1.EventDriver) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *UpdateDriverOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// UpdateDriverBadRequestCode is the HTTP code returned for type UpdateDriverBadRequest
const UpdateDriverBadRequestCode int = 400

/*UpdateDriverBadRequest Invalid Name supplied

swagger:response updateDriverBadRequest
*/
type UpdateDriverBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewUpdateDriverBadRequest creates UpdateDriverBadRequest with default headers values
func NewUpdateDriverBadRequest() *UpdateDriverBadRequest {

	return &UpdateDriverBadRequest{}
}

// WithPayload adds the payload to the update driver bad request response
func (o *UpdateDriverBadRequest) WithPayload(payload *v1.Error) *UpdateDriverBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the update driver bad request response
func (o *UpdateDriverBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *UpdateDriverBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// UpdateDriverUnauthorizedCode is the HTTP code returned for type UpdateDriverUnauthorized
const UpdateDriverUnauthorizedCode int = 401

/*UpdateDriverUnauthorized Unauthorized Request

swagger:response updateDriverUnauthorized
*/
type UpdateDriverUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewUpdateDriverUnauthorized creates UpdateDriverUnauthorized with default headers values
func NewUpdateDriverUnauthorized() *UpdateDriverUnauthorized {

	return &UpdateDriverUnauthorized{}
}

// WithPayload adds the payload to the update driver unauthorized response
func (o *UpdateDriverUnauthorized) WithPayload(payload *v1.Error) *UpdateDriverUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the update driver unauthorized response
func (o *UpdateDriverUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *UpdateDriverUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// UpdateDriverForbiddenCode is the HTTP code returned for type UpdateDriverForbidden
const UpdateDriverForbiddenCode int = 403

/*UpdateDriverForbidden access to this resource is forbidden

swagger:response updateDriverForbidden
*/
type UpdateDriverForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewUpdateDriverForbidden creates UpdateDriverForbidden with default headers values
func NewUpdateDriverForbidden() *UpdateDriverForbidden {

	return &UpdateDriverForbidden{}
}

// WithPayload adds the payload to the update driver forbidden response
func (o *UpdateDriverForbidden) WithPayload(payload *v1.Error) *UpdateDriverForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the update driver forbidden response
func (o *UpdateDriverForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *UpdateDriverForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// UpdateDriverNotFoundCode is the HTTP code returned for type UpdateDriverNotFound
const UpdateDriverNotFoundCode int = 404

/*UpdateDriverNotFound Driver not found

swagger:response updateDriverNotFound
*/
type UpdateDriverNotFound struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewUpdateDriverNotFound creates UpdateDriverNotFound with default headers values
func NewUpdateDriverNotFound() *UpdateDriverNotFound {

	return &UpdateDriverNotFound{}
}

// WithPayload adds the payload to the update driver not found response
func (o *UpdateDriverNotFound) WithPayload(payload *v1.Error) *UpdateDriverNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the update driver not found response
func (o *UpdateDriverNotFound) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *UpdateDriverNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*UpdateDriverDefault Unknown error

swagger:response updateDriverDefault
*/
type UpdateDriverDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewUpdateDriverDefault creates UpdateDriverDefault with default headers values
func NewUpdateDriverDefault(code int) *UpdateDriverDefault {
	if code <= 0 {
		code = 500
	}

	return &UpdateDriverDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the update driver default response
func (o *UpdateDriverDefault) WithStatusCode(code int) *UpdateDriverDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the update driver default response
func (o *UpdateDriverDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the update driver default response
func (o *UpdateDriverDefault) WithPayload(payload *v1.Error) *UpdateDriverDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the update driver default response
func (o *UpdateDriverDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *UpdateDriverDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
