///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// AddSubscriptionHandlerFunc turns a function with the right signature into a add subscription handler
type AddSubscriptionHandlerFunc func(AddSubscriptionParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn AddSubscriptionHandlerFunc) Handle(params AddSubscriptionParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// AddSubscriptionHandler interface for that can handle valid add subscription params
type AddSubscriptionHandler interface {
	Handle(AddSubscriptionParams, interface{}) middleware.Responder
}

// NewAddSubscription creates a new http.Handler for the add subscription operation
func NewAddSubscription(ctx *middleware.Context, handler AddSubscriptionHandler) *AddSubscription {
	return &AddSubscription{Context: ctx, Handler: handler}
}

/*AddSubscription swagger:route POST /subscriptions subscriptions addSubscription

Add a new subscription

*/
type AddSubscription struct {
	Context *middleware.Context
	Handler AddSubscriptionHandler
}

func (o *AddSubscription) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewAddSubscriptionParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
