///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// DeleteSubscriptionHandlerFunc turns a function with the right signature into a delete subscription handler
type DeleteSubscriptionHandlerFunc func(DeleteSubscriptionParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn DeleteSubscriptionHandlerFunc) Handle(params DeleteSubscriptionParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// DeleteSubscriptionHandler interface for that can handle valid delete subscription params
type DeleteSubscriptionHandler interface {
	Handle(DeleteSubscriptionParams, interface{}) middleware.Responder
}

// NewDeleteSubscription creates a new http.Handler for the delete subscription operation
func NewDeleteSubscription(ctx *middleware.Context, handler DeleteSubscriptionHandler) *DeleteSubscription {
	return &DeleteSubscription{Context: ctx, Handler: handler}
}

/*DeleteSubscription swagger:route DELETE /subscriptions/{subscriptionName} subscriptions deleteSubscription

Deletes a subscription

*/
type DeleteSubscription struct {
	Context *middleware.Context
	Handler DeleteSubscriptionHandler
}

func (o *DeleteSubscription) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewDeleteSubscriptionParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
