///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// GetSubscriptionHandlerFunc turns a function with the right signature into a get subscription handler
type GetSubscriptionHandlerFunc func(GetSubscriptionParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetSubscriptionHandlerFunc) Handle(params GetSubscriptionParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetSubscriptionHandler interface for that can handle valid get subscription params
type GetSubscriptionHandler interface {
	Handle(GetSubscriptionParams, interface{}) middleware.Responder
}

// NewGetSubscription creates a new http.Handler for the get subscription operation
func NewGetSubscription(ctx *middleware.Context, handler GetSubscriptionHandler) *GetSubscription {
	return &GetSubscription{Context: ctx, Handler: handler}
}

/*GetSubscription swagger:route GET /subscriptions/{subscriptionName} subscriptions getSubscription

Find subscription by Name

Returns a single subscription

*/
type GetSubscription struct {
	Context *middleware.Context
	Handler GetSubscriptionHandler
}

func (o *GetSubscription) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetSubscriptionParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
