///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package subscriptions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// GetSubscriptionsOKCode is the HTTP code returned for type GetSubscriptionsOK
const GetSubscriptionsOKCode int = 200

/*GetSubscriptionsOK Successful operation

swagger:response getSubscriptionsOK
*/
type GetSubscriptionsOK struct {

	/*
	  In: Body
	*/
	Payload []*v1.Subscription `json:"body,omitempty"`
}

// NewGetSubscriptionsOK creates GetSubscriptionsOK with default headers values
func NewGetSubscriptionsOK() *GetSubscriptionsOK {

	return &GetSubscriptionsOK{}
}

// WithPayload adds the payload to the get subscriptions o k response
func (o *GetSubscriptionsOK) WithPayload(payload []*v1.Subscription) *GetSubscriptionsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get subscriptions o k response
func (o *GetSubscriptionsOK) SetPayload(payload []*v1.Subscription) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSubscriptionsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		payload = make([]*v1.Subscription, 0, 50)
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}

}

// GetSubscriptionsBadRequestCode is the HTTP code returned for type GetSubscriptionsBadRequest
const GetSubscriptionsBadRequestCode int = 400

/*GetSubscriptionsBadRequest Bad Request

swagger:response getSubscriptionsBadRequest
*/
type GetSubscriptionsBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetSubscriptionsBadRequest creates GetSubscriptionsBadRequest with default headers values
func NewGetSubscriptionsBadRequest() *GetSubscriptionsBadRequest {

	return &GetSubscriptionsBadRequest{}
}

// WithPayload adds the payload to the get subscriptions bad request response
func (o *GetSubscriptionsBadRequest) WithPayload(payload *v1.Error) *GetSubscriptionsBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get subscriptions bad request response
func (o *GetSubscriptionsBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSubscriptionsBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetSubscriptionsUnauthorizedCode is the HTTP code returned for type GetSubscriptionsUnauthorized
const GetSubscriptionsUnauthorizedCode int = 401

/*GetSubscriptionsUnauthorized Unauthorized Request

swagger:response getSubscriptionsUnauthorized
*/
type GetSubscriptionsUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetSubscriptionsUnauthorized creates GetSubscriptionsUnauthorized with default headers values
func NewGetSubscriptionsUnauthorized() *GetSubscriptionsUnauthorized {

	return &GetSubscriptionsUnauthorized{}
}

// WithPayload adds the payload to the get subscriptions unauthorized response
func (o *GetSubscriptionsUnauthorized) WithPayload(payload *v1.Error) *GetSubscriptionsUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get subscriptions unauthorized response
func (o *GetSubscriptionsUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSubscriptionsUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetSubscriptionsForbiddenCode is the HTTP code returned for type GetSubscriptionsForbidden
const GetSubscriptionsForbiddenCode int = 403

/*GetSubscriptionsForbidden access to this resource is forbidden

swagger:response getSubscriptionsForbidden
*/
type GetSubscriptionsForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetSubscriptionsForbidden creates GetSubscriptionsForbidden with default headers values
func NewGetSubscriptionsForbidden() *GetSubscriptionsForbidden {

	return &GetSubscriptionsForbidden{}
}

// WithPayload adds the payload to the get subscriptions forbidden response
func (o *GetSubscriptionsForbidden) WithPayload(payload *v1.Error) *GetSubscriptionsForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get subscriptions forbidden response
func (o *GetSubscriptionsForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSubscriptionsForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*GetSubscriptionsDefault Unknown error

swagger:response getSubscriptionsDefault
*/
type GetSubscriptionsDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetSubscriptionsDefault creates GetSubscriptionsDefault with default headers values
func NewGetSubscriptionsDefault(code int) *GetSubscriptionsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetSubscriptionsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get subscriptions default response
func (o *GetSubscriptionsDefault) WithStatusCode(code int) *GetSubscriptionsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get subscriptions default response
func (o *GetSubscriptionsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get subscriptions default response
func (o *GetSubscriptionsDefault) WithPayload(payload *v1.Error) *GetSubscriptionsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get subscriptions default response
func (o *GetSubscriptionsDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetSubscriptionsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
