///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package runner

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// GetRunsReader is a Reader for the GetRuns structure.
type GetRunsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRunsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetRunsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewGetRunsBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewGetRunsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewGetRunsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewGetRunsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewGetRunsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetRunsOK creates a GetRunsOK with default headers values
func NewGetRunsOK() *GetRunsOK {
	return &GetRunsOK{}
}

/*GetRunsOK handles this case with default header values.

List of function runs
*/
type GetRunsOK struct {
	Payload []*v1.Run
}

func (o *GetRunsOK) Error() string {
	return fmt.Sprintf("[GET /runs][%d] getRunsOK  %+v", 200, o.Payload)
}

func (o *GetRunsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRunsBadRequest creates a GetRunsBadRequest with default headers values
func NewGetRunsBadRequest() *GetRunsBadRequest {
	return &GetRunsBadRequest{}
}

/*GetRunsBadRequest handles this case with default header values.

Invalid input
*/
type GetRunsBadRequest struct {
	Payload *v1.Error
}

func (o *GetRunsBadRequest) Error() string {
	return fmt.Sprintf("[GET /runs][%d] getRunsBadRequest  %+v", 400, o.Payload)
}

func (o *GetRunsBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRunsUnauthorized creates a GetRunsUnauthorized with default headers values
func NewGetRunsUnauthorized() *GetRunsUnauthorized {
	return &GetRunsUnauthorized{}
}

/*GetRunsUnauthorized handles this case with default header values.

Unauthorized Request
*/
type GetRunsUnauthorized struct {
	Payload *v1.Error
}

func (o *GetRunsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /runs][%d] getRunsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetRunsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRunsForbidden creates a GetRunsForbidden with default headers values
func NewGetRunsForbidden() *GetRunsForbidden {
	return &GetRunsForbidden{}
}

/*GetRunsForbidden handles this case with default header values.

access to this resource is forbidden
*/
type GetRunsForbidden struct {
	Payload *v1.Error
}

func (o *GetRunsForbidden) Error() string {
	return fmt.Sprintf("[GET /runs][%d] getRunsForbidden  %+v", 403, o.Payload)
}

func (o *GetRunsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRunsNotFound creates a GetRunsNotFound with default headers values
func NewGetRunsNotFound() *GetRunsNotFound {
	return &GetRunsNotFound{}
}

/*GetRunsNotFound handles this case with default header values.

Function not found
*/
type GetRunsNotFound struct {
	Payload *v1.Error
}

func (o *GetRunsNotFound) Error() string {
	return fmt.Sprintf("[GET /runs][%d] getRunsNotFound  %+v", 404, o.Payload)
}

func (o *GetRunsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRunsDefault creates a GetRunsDefault with default headers values
func NewGetRunsDefault(code int) *GetRunsDefault {
	return &GetRunsDefault{
		_statusCode: code,
	}
}

/*GetRunsDefault handles this case with default header values.

Unknown error
*/
type GetRunsDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the get runs default response
func (o *GetRunsDefault) Code() int {
	return o._statusCode
}

func (o *GetRunsDefault) Error() string {
	return fmt.Sprintf("[GET /runs][%d] getRuns default  %+v", o._statusCode, o.Payload)
}

func (o *GetRunsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
