///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// AddFunctionReader is a Reader for the AddFunction structure.
type AddFunctionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddFunctionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 201:
		result := NewAddFunctionCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewAddFunctionBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewAddFunctionUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewAddFunctionForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 409:
		result := NewAddFunctionConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewAddFunctionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddFunctionCreated creates a AddFunctionCreated with default headers values
func NewAddFunctionCreated() *AddFunctionCreated {
	return &AddFunctionCreated{}
}

/*AddFunctionCreated handles this case with default header values.

Function created
*/
type AddFunctionCreated struct {
	Payload *v1.Function
}

func (o *AddFunctionCreated) Error() string {
	return fmt.Sprintf("[POST /function][%d] addFunctionCreated  %+v", 201, o.Payload)
}

func (o *AddFunctionCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Function)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddFunctionBadRequest creates a AddFunctionBadRequest with default headers values
func NewAddFunctionBadRequest() *AddFunctionBadRequest {
	return &AddFunctionBadRequest{}
}

/*AddFunctionBadRequest handles this case with default header values.

Invalid input
*/
type AddFunctionBadRequest struct {
	Payload *v1.Error
}

func (o *AddFunctionBadRequest) Error() string {
	return fmt.Sprintf("[POST /function][%d] addFunctionBadRequest  %+v", 400, o.Payload)
}

func (o *AddFunctionBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddFunctionUnauthorized creates a AddFunctionUnauthorized with default headers values
func NewAddFunctionUnauthorized() *AddFunctionUnauthorized {
	return &AddFunctionUnauthorized{}
}

/*AddFunctionUnauthorized handles this case with default header values.

Unauthorized Request
*/
type AddFunctionUnauthorized struct {
	Payload *v1.Error
}

func (o *AddFunctionUnauthorized) Error() string {
	return fmt.Sprintf("[POST /function][%d] addFunctionUnauthorized  %+v", 401, o.Payload)
}

func (o *AddFunctionUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddFunctionForbidden creates a AddFunctionForbidden with default headers values
func NewAddFunctionForbidden() *AddFunctionForbidden {
	return &AddFunctionForbidden{}
}

/*AddFunctionForbidden handles this case with default header values.

access to this resource is forbidden
*/
type AddFunctionForbidden struct {
	Payload *v1.Error
}

func (o *AddFunctionForbidden) Error() string {
	return fmt.Sprintf("[POST /function][%d] addFunctionForbidden  %+v", 403, o.Payload)
}

func (o *AddFunctionForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddFunctionConflict creates a AddFunctionConflict with default headers values
func NewAddFunctionConflict() *AddFunctionConflict {
	return &AddFunctionConflict{}
}

/*AddFunctionConflict handles this case with default header values.

Already Exists
*/
type AddFunctionConflict struct {
	Payload *v1.Error
}

func (o *AddFunctionConflict) Error() string {
	return fmt.Sprintf("[POST /function][%d] addFunctionConflict  %+v", 409, o.Payload)
}

func (o *AddFunctionConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddFunctionDefault creates a AddFunctionDefault with default headers values
func NewAddFunctionDefault(code int) *AddFunctionDefault {
	return &AddFunctionDefault{
		_statusCode: code,
	}
}

/*AddFunctionDefault handles this case with default header values.

Unknown error
*/
type AddFunctionDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the add function default response
func (o *AddFunctionDefault) Code() int {
	return o._statusCode
}

func (o *AddFunctionDefault) Error() string {
	return fmt.Sprintf("[POST /function][%d] addFunction default  %+v", o._statusCode, o.Payload)
}

func (o *AddFunctionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
