///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewDeleteFunctionParams creates a new DeleteFunctionParams object
// with the default values initialized.
func NewDeleteFunctionParams() *DeleteFunctionParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &DeleteFunctionParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteFunctionParamsWithTimeout creates a new DeleteFunctionParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDeleteFunctionParamsWithTimeout(timeout time.Duration) *DeleteFunctionParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &DeleteFunctionParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: timeout,
	}
}

// NewDeleteFunctionParamsWithContext creates a new DeleteFunctionParams object
// with the default values initialized, and the ability to set a context for a request
func NewDeleteFunctionParamsWithContext(ctx context.Context) *DeleteFunctionParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &DeleteFunctionParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		Context: ctx,
	}
}

// NewDeleteFunctionParamsWithHTTPClient creates a new DeleteFunctionParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewDeleteFunctionParamsWithHTTPClient(client *http.Client) *DeleteFunctionParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &DeleteFunctionParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,
		HTTPClient:       client,
	}
}

/*DeleteFunctionParams contains all the parameters to send to the API endpoint
for the delete function operation typically these are written to a http.Request
*/
type DeleteFunctionParams struct {

	/*XDispatchOrg*/
	XDispatchOrg *string
	/*XDispatchProject*/
	XDispatchProject *string
	/*FunctionName
	  Name of function to work on

	*/
	FunctionName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the delete function params
func (o *DeleteFunctionParams) WithTimeout(timeout time.Duration) *DeleteFunctionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete function params
func (o *DeleteFunctionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete function params
func (o *DeleteFunctionParams) WithContext(ctx context.Context) *DeleteFunctionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete function params
func (o *DeleteFunctionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete function params
func (o *DeleteFunctionParams) WithHTTPClient(client *http.Client) *DeleteFunctionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete function params
func (o *DeleteFunctionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the delete function params
func (o *DeleteFunctionParams) WithXDispatchOrg(xDispatchOrg *string) *DeleteFunctionParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the delete function params
func (o *DeleteFunctionParams) SetXDispatchOrg(xDispatchOrg *string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithXDispatchProject adds the xDispatchProject to the delete function params
func (o *DeleteFunctionParams) WithXDispatchProject(xDispatchProject *string) *DeleteFunctionParams {
	o.SetXDispatchProject(xDispatchProject)
	return o
}

// SetXDispatchProject adds the xDispatchProject to the delete function params
func (o *DeleteFunctionParams) SetXDispatchProject(xDispatchProject *string) {
	o.XDispatchProject = xDispatchProject
}

// WithFunctionName adds the functionName to the delete function params
func (o *DeleteFunctionParams) WithFunctionName(functionName string) *DeleteFunctionParams {
	o.SetFunctionName(functionName)
	return o
}

// SetFunctionName adds the functionName to the delete function params
func (o *DeleteFunctionParams) SetFunctionName(functionName string) {
	o.FunctionName = functionName
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteFunctionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XDispatchOrg != nil {

		// header param X-Dispatch-Org
		if err := r.SetHeaderParam("X-Dispatch-Org", *o.XDispatchOrg); err != nil {
			return err
		}

	}

	if o.XDispatchProject != nil {

		// header param X-Dispatch-Project
		if err := r.SetHeaderParam("X-Dispatch-Project", *o.XDispatchProject); err != nil {
			return err
		}

	}

	// path param functionName
	if err := r.SetPathParam("functionName", o.FunctionName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
