///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// GetFunctionsReader is a Reader for the GetFunctions structure.
type GetFunctionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetFunctionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetFunctionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewGetFunctionsBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewGetFunctionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewGetFunctionsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewGetFunctionsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetFunctionsOK creates a GetFunctionsOK with default headers values
func NewGetFunctionsOK() *GetFunctionsOK {
	return &GetFunctionsOK{}
}

/*GetFunctionsOK handles this case with default header values.

Successful operation
*/
type GetFunctionsOK struct {
	Payload []*v1.Function
}

func (o *GetFunctionsOK) Error() string {
	return fmt.Sprintf("[GET /function][%d] getFunctionsOK  %+v", 200, o.Payload)
}

func (o *GetFunctionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFunctionsBadRequest creates a GetFunctionsBadRequest with default headers values
func NewGetFunctionsBadRequest() *GetFunctionsBadRequest {
	return &GetFunctionsBadRequest{}
}

/*GetFunctionsBadRequest handles this case with default header values.

Invalid input
*/
type GetFunctionsBadRequest struct {
	Payload *v1.Error
}

func (o *GetFunctionsBadRequest) Error() string {
	return fmt.Sprintf("[GET /function][%d] getFunctionsBadRequest  %+v", 400, o.Payload)
}

func (o *GetFunctionsBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFunctionsUnauthorized creates a GetFunctionsUnauthorized with default headers values
func NewGetFunctionsUnauthorized() *GetFunctionsUnauthorized {
	return &GetFunctionsUnauthorized{}
}

/*GetFunctionsUnauthorized handles this case with default header values.

Unauthorized Request
*/
type GetFunctionsUnauthorized struct {
	Payload *v1.Error
}

func (o *GetFunctionsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /function][%d] getFunctionsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetFunctionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFunctionsForbidden creates a GetFunctionsForbidden with default headers values
func NewGetFunctionsForbidden() *GetFunctionsForbidden {
	return &GetFunctionsForbidden{}
}

/*GetFunctionsForbidden handles this case with default header values.

access to this resource is forbidden
*/
type GetFunctionsForbidden struct {
	Payload *v1.Error
}

func (o *GetFunctionsForbidden) Error() string {
	return fmt.Sprintf("[GET /function][%d] getFunctionsForbidden  %+v", 403, o.Payload)
}

func (o *GetFunctionsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFunctionsDefault creates a GetFunctionsDefault with default headers values
func NewGetFunctionsDefault(code int) *GetFunctionsDefault {
	return &GetFunctionsDefault{
		_statusCode: code,
	}
}

/*GetFunctionsDefault handles this case with default header values.

Unknown error
*/
type GetFunctionsDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the get functions default response
func (o *GetFunctionsDefault) Code() int {
	return o._statusCode
}

func (o *GetFunctionsDefault) Error() string {
	return fmt.Sprintf("[GET /function][%d] getFunctions default  %+v", o._statusCode, o.Payload)
}

func (o *GetFunctionsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
