///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package runner

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// RunFunctionOKCode is the HTTP code returned for type RunFunctionOK
const RunFunctionOKCode int = 200

/*RunFunctionOK Successful execution (blocking call)

swagger:response runFunctionOK
*/
type RunFunctionOK struct {

	/*
	  In: Body
	*/
	Payload *v1.Run `json:"body,omitempty"`
}

// NewRunFunctionOK creates RunFunctionOK with default headers values
func NewRunFunctionOK() *RunFunctionOK {

	return &RunFunctionOK{}
}

// WithPayload adds the payload to the run function o k response
func (o *RunFunctionOK) WithPayload(payload *v1.Run) *RunFunctionOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the run function o k response
func (o *RunFunctionOK) SetPayload(payload *v1.Run) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RunFunctionOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// RunFunctionAcceptedCode is the HTTP code returned for type RunFunctionAccepted
const RunFunctionAcceptedCode int = 202

/*RunFunctionAccepted Execution started (non-blocking call)

swagger:response runFunctionAccepted
*/
type RunFunctionAccepted struct {

	/*
	  In: Body
	*/
	Payload *v1.Run `json:"body,omitempty"`
}

// NewRunFunctionAccepted creates RunFunctionAccepted with default headers values
func NewRunFunctionAccepted() *RunFunctionAccepted {

	return &RunFunctionAccepted{}
}

// WithPayload adds the payload to the run function accepted response
func (o *RunFunctionAccepted) WithPayload(payload *v1.Run) *RunFunctionAccepted {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the run function accepted response
func (o *RunFunctionAccepted) SetPayload(payload *v1.Run) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RunFunctionAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(202)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// RunFunctionBadRequestCode is the HTTP code returned for type RunFunctionBadRequest
const RunFunctionBadRequestCode int = 400

/*RunFunctionBadRequest User error

swagger:response runFunctionBadRequest
*/
type RunFunctionBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRunFunctionBadRequest creates RunFunctionBadRequest with default headers values
func NewRunFunctionBadRequest() *RunFunctionBadRequest {

	return &RunFunctionBadRequest{}
}

// WithPayload adds the payload to the run function bad request response
func (o *RunFunctionBadRequest) WithPayload(payload *v1.Error) *RunFunctionBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the run function bad request response
func (o *RunFunctionBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RunFunctionBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// RunFunctionUnauthorizedCode is the HTTP code returned for type RunFunctionUnauthorized
const RunFunctionUnauthorizedCode int = 401

/*RunFunctionUnauthorized Unauthorized Request

swagger:response runFunctionUnauthorized
*/
type RunFunctionUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRunFunctionUnauthorized creates RunFunctionUnauthorized with default headers values
func NewRunFunctionUnauthorized() *RunFunctionUnauthorized {

	return &RunFunctionUnauthorized{}
}

// WithPayload adds the payload to the run function unauthorized response
func (o *RunFunctionUnauthorized) WithPayload(payload *v1.Error) *RunFunctionUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the run function unauthorized response
func (o *RunFunctionUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RunFunctionUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// RunFunctionForbiddenCode is the HTTP code returned for type RunFunctionForbidden
const RunFunctionForbiddenCode int = 403

/*RunFunctionForbidden access to this resource is forbidden

swagger:response runFunctionForbidden
*/
type RunFunctionForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRunFunctionForbidden creates RunFunctionForbidden with default headers values
func NewRunFunctionForbidden() *RunFunctionForbidden {

	return &RunFunctionForbidden{}
}

// WithPayload adds the payload to the run function forbidden response
func (o *RunFunctionForbidden) WithPayload(payload *v1.Error) *RunFunctionForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the run function forbidden response
func (o *RunFunctionForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RunFunctionForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// RunFunctionNotFoundCode is the HTTP code returned for type RunFunctionNotFound
const RunFunctionNotFoundCode int = 404

/*RunFunctionNotFound Function not found

swagger:response runFunctionNotFound
*/
type RunFunctionNotFound struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRunFunctionNotFound creates RunFunctionNotFound with default headers values
func NewRunFunctionNotFound() *RunFunctionNotFound {

	return &RunFunctionNotFound{}
}

// WithPayload adds the payload to the run function not found response
func (o *RunFunctionNotFound) WithPayload(payload *v1.Error) *RunFunctionNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the run function not found response
func (o *RunFunctionNotFound) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RunFunctionNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// RunFunctionUnprocessableEntityCode is the HTTP code returned for type RunFunctionUnprocessableEntity
const RunFunctionUnprocessableEntityCode int = 422

/*RunFunctionUnprocessableEntity Input object validation failed

swagger:response runFunctionUnprocessableEntity
*/
type RunFunctionUnprocessableEntity struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRunFunctionUnprocessableEntity creates RunFunctionUnprocessableEntity with default headers values
func NewRunFunctionUnprocessableEntity() *RunFunctionUnprocessableEntity {

	return &RunFunctionUnprocessableEntity{}
}

// WithPayload adds the payload to the run function unprocessable entity response
func (o *RunFunctionUnprocessableEntity) WithPayload(payload *v1.Error) *RunFunctionUnprocessableEntity {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the run function unprocessable entity response
func (o *RunFunctionUnprocessableEntity) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RunFunctionUnprocessableEntity) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(422)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// RunFunctionBadGatewayCode is the HTTP code returned for type RunFunctionBadGateway
const RunFunctionBadGatewayCode int = 502

/*RunFunctionBadGateway Function error occurred (blocking call)

swagger:response runFunctionBadGateway
*/
type RunFunctionBadGateway struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRunFunctionBadGateway creates RunFunctionBadGateway with default headers values
func NewRunFunctionBadGateway() *RunFunctionBadGateway {

	return &RunFunctionBadGateway{}
}

// WithPayload adds the payload to the run function bad gateway response
func (o *RunFunctionBadGateway) WithPayload(payload *v1.Error) *RunFunctionBadGateway {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the run function bad gateway response
func (o *RunFunctionBadGateway) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RunFunctionBadGateway) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(502)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*RunFunctionDefault Unknown error

swagger:response runFunctionDefault
*/
type RunFunctionDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRunFunctionDefault creates RunFunctionDefault with default headers values
func NewRunFunctionDefault(code int) *RunFunctionDefault {
	if code <= 0 {
		code = 500
	}

	return &RunFunctionDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the run function default response
func (o *RunFunctionDefault) WithStatusCode(code int) *RunFunctionDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the run function default response
func (o *RunFunctionDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the run function default response
func (o *RunFunctionDefault) WithPayload(payload *v1.Error) *RunFunctionDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the run function default response
func (o *RunFunctionDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RunFunctionDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
