///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// DeleteFunctionOKCode is the HTTP code returned for type DeleteFunctionOK
const DeleteFunctionOKCode int = 200

/*DeleteFunctionOK Successful operation

swagger:response deleteFunctionOK
*/
type DeleteFunctionOK struct {

	/*
	  In: Body
	*/
	Payload *v1.Function `json:"body,omitempty"`
}

// NewDeleteFunctionOK creates DeleteFunctionOK with default headers values
func NewDeleteFunctionOK() *DeleteFunctionOK {

	return &DeleteFunctionOK{}
}

// WithPayload adds the payload to the delete function o k response
func (o *DeleteFunctionOK) WithPayload(payload *v1.Function) *DeleteFunctionOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete function o k response
func (o *DeleteFunctionOK) SetPayload(payload *v1.Function) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteFunctionOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteFunctionBadRequestCode is the HTTP code returned for type DeleteFunctionBadRequest
const DeleteFunctionBadRequestCode int = 400

/*DeleteFunctionBadRequest Invalid Name supplied

swagger:response deleteFunctionBadRequest
*/
type DeleteFunctionBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteFunctionBadRequest creates DeleteFunctionBadRequest with default headers values
func NewDeleteFunctionBadRequest() *DeleteFunctionBadRequest {

	return &DeleteFunctionBadRequest{}
}

// WithPayload adds the payload to the delete function bad request response
func (o *DeleteFunctionBadRequest) WithPayload(payload *v1.Error) *DeleteFunctionBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete function bad request response
func (o *DeleteFunctionBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteFunctionBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteFunctionUnauthorizedCode is the HTTP code returned for type DeleteFunctionUnauthorized
const DeleteFunctionUnauthorizedCode int = 401

/*DeleteFunctionUnauthorized Unauthorized Request

swagger:response deleteFunctionUnauthorized
*/
type DeleteFunctionUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteFunctionUnauthorized creates DeleteFunctionUnauthorized with default headers values
func NewDeleteFunctionUnauthorized() *DeleteFunctionUnauthorized {

	return &DeleteFunctionUnauthorized{}
}

// WithPayload adds the payload to the delete function unauthorized response
func (o *DeleteFunctionUnauthorized) WithPayload(payload *v1.Error) *DeleteFunctionUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete function unauthorized response
func (o *DeleteFunctionUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteFunctionUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteFunctionForbiddenCode is the HTTP code returned for type DeleteFunctionForbidden
const DeleteFunctionForbiddenCode int = 403

/*DeleteFunctionForbidden access to this resource is forbidden

swagger:response deleteFunctionForbidden
*/
type DeleteFunctionForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteFunctionForbidden creates DeleteFunctionForbidden with default headers values
func NewDeleteFunctionForbidden() *DeleteFunctionForbidden {

	return &DeleteFunctionForbidden{}
}

// WithPayload adds the payload to the delete function forbidden response
func (o *DeleteFunctionForbidden) WithPayload(payload *v1.Error) *DeleteFunctionForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete function forbidden response
func (o *DeleteFunctionForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteFunctionForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteFunctionNotFoundCode is the HTTP code returned for type DeleteFunctionNotFound
const DeleteFunctionNotFoundCode int = 404

/*DeleteFunctionNotFound Function not found

swagger:response deleteFunctionNotFound
*/
type DeleteFunctionNotFound struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteFunctionNotFound creates DeleteFunctionNotFound with default headers values
func NewDeleteFunctionNotFound() *DeleteFunctionNotFound {

	return &DeleteFunctionNotFound{}
}

// WithPayload adds the payload to the delete function not found response
func (o *DeleteFunctionNotFound) WithPayload(payload *v1.Error) *DeleteFunctionNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete function not found response
func (o *DeleteFunctionNotFound) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteFunctionNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*DeleteFunctionDefault Unknown error

swagger:response deleteFunctionDefault
*/
type DeleteFunctionDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteFunctionDefault creates DeleteFunctionDefault with default headers values
func NewDeleteFunctionDefault(code int) *DeleteFunctionDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteFunctionDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete function default response
func (o *DeleteFunctionDefault) WithStatusCode(code int) *DeleteFunctionDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete function default response
func (o *DeleteFunctionDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the delete function default response
func (o *DeleteFunctionDefault) WithPayload(payload *v1.Error) *DeleteFunctionDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete function default response
func (o *DeleteFunctionDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteFunctionDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
