///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// GetFunctionsOKCode is the HTTP code returned for type GetFunctionsOK
const GetFunctionsOKCode int = 200

/*GetFunctionsOK Successful operation

swagger:response getFunctionsOK
*/
type GetFunctionsOK struct {

	/*
	  In: Body
	*/
	Payload []*v1.Function `json:"body,omitempty"`
}

// NewGetFunctionsOK creates GetFunctionsOK with default headers values
func NewGetFunctionsOK() *GetFunctionsOK {

	return &GetFunctionsOK{}
}

// WithPayload adds the payload to the get functions o k response
func (o *GetFunctionsOK) WithPayload(payload []*v1.Function) *GetFunctionsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get functions o k response
func (o *GetFunctionsOK) SetPayload(payload []*v1.Function) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetFunctionsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		payload = make([]*v1.Function, 0, 50)
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}

}

// GetFunctionsBadRequestCode is the HTTP code returned for type GetFunctionsBadRequest
const GetFunctionsBadRequestCode int = 400

/*GetFunctionsBadRequest Invalid input

swagger:response getFunctionsBadRequest
*/
type GetFunctionsBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetFunctionsBadRequest creates GetFunctionsBadRequest with default headers values
func NewGetFunctionsBadRequest() *GetFunctionsBadRequest {

	return &GetFunctionsBadRequest{}
}

// WithPayload adds the payload to the get functions bad request response
func (o *GetFunctionsBadRequest) WithPayload(payload *v1.Error) *GetFunctionsBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get functions bad request response
func (o *GetFunctionsBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetFunctionsBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetFunctionsUnauthorizedCode is the HTTP code returned for type GetFunctionsUnauthorized
const GetFunctionsUnauthorizedCode int = 401

/*GetFunctionsUnauthorized Unauthorized Request

swagger:response getFunctionsUnauthorized
*/
type GetFunctionsUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetFunctionsUnauthorized creates GetFunctionsUnauthorized with default headers values
func NewGetFunctionsUnauthorized() *GetFunctionsUnauthorized {

	return &GetFunctionsUnauthorized{}
}

// WithPayload adds the payload to the get functions unauthorized response
func (o *GetFunctionsUnauthorized) WithPayload(payload *v1.Error) *GetFunctionsUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get functions unauthorized response
func (o *GetFunctionsUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetFunctionsUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetFunctionsForbiddenCode is the HTTP code returned for type GetFunctionsForbidden
const GetFunctionsForbiddenCode int = 403

/*GetFunctionsForbidden access to this resource is forbidden

swagger:response getFunctionsForbidden
*/
type GetFunctionsForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetFunctionsForbidden creates GetFunctionsForbidden with default headers values
func NewGetFunctionsForbidden() *GetFunctionsForbidden {

	return &GetFunctionsForbidden{}
}

// WithPayload adds the payload to the get functions forbidden response
func (o *GetFunctionsForbidden) WithPayload(payload *v1.Error) *GetFunctionsForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get functions forbidden response
func (o *GetFunctionsForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetFunctionsForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*GetFunctionsDefault Unknown error

swagger:response getFunctionsDefault
*/
type GetFunctionsDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetFunctionsDefault creates GetFunctionsDefault with default headers values
func NewGetFunctionsDefault(code int) *GetFunctionsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetFunctionsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get functions default response
func (o *GetFunctionsDefault) WithStatusCode(code int) *GetFunctionsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get functions default response
func (o *GetFunctionsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get functions default response
func (o *GetFunctionsDefault) WithPayload(payload *v1.Error) *GetFunctionsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get functions default response
func (o *GetFunctionsDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetFunctionsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
