///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewAuthParams creates a new AuthParams object
// with the default values initialized.
func NewAuthParams() *AuthParams {
	var ()
	return &AuthParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewAuthParamsWithTimeout creates a new AuthParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewAuthParamsWithTimeout(timeout time.Duration) *AuthParams {
	var ()
	return &AuthParams{

		timeout: timeout,
	}
}

// NewAuthParamsWithContext creates a new AuthParams object
// with the default values initialized, and the ability to set a context for a request
func NewAuthParamsWithContext(ctx context.Context) *AuthParams {
	var ()
	return &AuthParams{

		Context: ctx,
	}
}

// NewAuthParamsWithHTTPClient creates a new AuthParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewAuthParamsWithHTTPClient(client *http.Client) *AuthParams {
	var ()
	return &AuthParams{
		HTTPClient: client,
	}
}

/*AuthParams contains all the parameters to send to the API endpoint
for the auth operation typically these are written to a http.Request
*/
type AuthParams struct {

	/*XDispatchOrg*/
	XDispatchOrg *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the auth params
func (o *AuthParams) WithTimeout(timeout time.Duration) *AuthParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the auth params
func (o *AuthParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the auth params
func (o *AuthParams) WithContext(ctx context.Context) *AuthParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the auth params
func (o *AuthParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the auth params
func (o *AuthParams) WithHTTPClient(client *http.Client) *AuthParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the auth params
func (o *AuthParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the auth params
func (o *AuthParams) WithXDispatchOrg(xDispatchOrg *string) *AuthParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the auth params
func (o *AuthParams) SetXDispatchOrg(xDispatchOrg *string) {
	o.XDispatchOrg = xDispatchOrg
}

// WriteToRequest writes these params to a swagger request
func (o *AuthParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XDispatchOrg != nil {

		// header param X-Dispatch-Org
		if err := r.SetHeaderParam("X-Dispatch-Org", *o.XDispatchOrg); err != nil {
			return err
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
