///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewRootParams creates a new RootParams object
// with the default values initialized.
func NewRootParams() *RootParams {

	return &RootParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewRootParamsWithTimeout creates a new RootParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewRootParamsWithTimeout(timeout time.Duration) *RootParams {

	return &RootParams{

		timeout: timeout,
	}
}

// NewRootParamsWithContext creates a new RootParams object
// with the default values initialized, and the ability to set a context for a request
func NewRootParamsWithContext(ctx context.Context) *RootParams {

	return &RootParams{

		Context: ctx,
	}
}

// NewRootParamsWithHTTPClient creates a new RootParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewRootParamsWithHTTPClient(client *http.Client) *RootParams {

	return &RootParams{
		HTTPClient: client,
	}
}

/*RootParams contains all the parameters to send to the API endpoint
for the root operation typically these are written to a http.Request
*/
type RootParams struct {
	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the root params
func (o *RootParams) WithTimeout(timeout time.Duration) *RootParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the root params
func (o *RootParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the root params
func (o *RootParams) WithContext(ctx context.Context) *RootParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the root params
func (o *RootParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the root params
func (o *RootParams) WithHTTPClient(client *http.Client) *RootParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the root params
func (o *RootParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WriteToRequest writes these params to a swagger request
func (o *RootParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
