///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// RootReader is a Reader for the Root structure.
type RootReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *RootReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewRootOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 401:
		result := NewRootUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewRootForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewRootDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewRootOK creates a RootOK with default headers values
func NewRootOK() *RootOK {
	return &RootOK{}
}

/*RootOK handles this case with default header values.

home page
*/
type RootOK struct {
	Payload *v1.Message
}

func (o *RootOK) Error() string {
	return fmt.Sprintf("[GET /][%d] rootOK  %+v", 200, o.Payload)
}

func (o *RootOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Message)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRootUnauthorized creates a RootUnauthorized with default headers values
func NewRootUnauthorized() *RootUnauthorized {
	return &RootUnauthorized{}
}

/*RootUnauthorized handles this case with default header values.

Unauthorized Request
*/
type RootUnauthorized struct {
	Payload *v1.Error
}

func (o *RootUnauthorized) Error() string {
	return fmt.Sprintf("[GET /][%d] rootUnauthorized  %+v", 401, o.Payload)
}

func (o *RootUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRootForbidden creates a RootForbidden with default headers values
func NewRootForbidden() *RootForbidden {
	return &RootForbidden{}
}

/*RootForbidden handles this case with default header values.

access to this resource is forbidden
*/
type RootForbidden struct {
	Payload *v1.Error
}

func (o *RootForbidden) Error() string {
	return fmt.Sprintf("[GET /][%d] rootForbidden  %+v", 403, o.Payload)
}

func (o *RootForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRootDefault creates a RootDefault with default headers values
func NewRootDefault(code int) *RootDefault {
	return &RootDefault{
		_statusCode: code,
	}
}

/*RootDefault handles this case with default header values.

error
*/
type RootDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the root default response
func (o *RootDefault) Code() int {
	return o._statusCode
}

func (o *RootDefault) Error() string {
	return fmt.Sprintf("[GET /][%d] root default  %+v", o._statusCode, o.Payload)
}

func (o *RootDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
