///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetOrganizationParams creates a new GetOrganizationParams object
// with the default values initialized.
func NewGetOrganizationParams() *GetOrganizationParams {
	var ()
	return &GetOrganizationParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetOrganizationParamsWithTimeout creates a new GetOrganizationParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetOrganizationParamsWithTimeout(timeout time.Duration) *GetOrganizationParams {
	var ()
	return &GetOrganizationParams{

		timeout: timeout,
	}
}

// NewGetOrganizationParamsWithContext creates a new GetOrganizationParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetOrganizationParamsWithContext(ctx context.Context) *GetOrganizationParams {
	var ()
	return &GetOrganizationParams{

		Context: ctx,
	}
}

// NewGetOrganizationParamsWithHTTPClient creates a new GetOrganizationParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetOrganizationParamsWithHTTPClient(client *http.Client) *GetOrganizationParams {
	var ()
	return &GetOrganizationParams{
		HTTPClient: client,
	}
}

/*GetOrganizationParams contains all the parameters to send to the API endpoint
for the get organization operation typically these are written to a http.Request
*/
type GetOrganizationParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string
	/*OrganizationName
	  Name of Organization to work on

	*/
	OrganizationName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get organization params
func (o *GetOrganizationParams) WithTimeout(timeout time.Duration) *GetOrganizationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get organization params
func (o *GetOrganizationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get organization params
func (o *GetOrganizationParams) WithContext(ctx context.Context) *GetOrganizationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get organization params
func (o *GetOrganizationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get organization params
func (o *GetOrganizationParams) WithHTTPClient(client *http.Client) *GetOrganizationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get organization params
func (o *GetOrganizationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the get organization params
func (o *GetOrganizationParams) WithXDispatchOrg(xDispatchOrg string) *GetOrganizationParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the get organization params
func (o *GetOrganizationParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithOrganizationName adds the organizationName to the get organization params
func (o *GetOrganizationParams) WithOrganizationName(organizationName string) *GetOrganizationParams {
	o.SetOrganizationName(organizationName)
	return o
}

// SetOrganizationName adds the organizationName to the get organization params
func (o *GetOrganizationParams) SetOrganizationName(organizationName string) {
	o.OrganizationName = organizationName
}

// WriteToRequest writes these params to a swagger request
func (o *GetOrganizationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	// path param organizationName
	if err := r.SetPathParam("organizationName", o.OrganizationName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
