///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package policy

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// NewAddPolicyParams creates a new AddPolicyParams object
// with the default values initialized.
func NewAddPolicyParams() *AddPolicyParams {
	var ()
	return &AddPolicyParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewAddPolicyParamsWithTimeout creates a new AddPolicyParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewAddPolicyParamsWithTimeout(timeout time.Duration) *AddPolicyParams {
	var ()
	return &AddPolicyParams{

		timeout: timeout,
	}
}

// NewAddPolicyParamsWithContext creates a new AddPolicyParams object
// with the default values initialized, and the ability to set a context for a request
func NewAddPolicyParamsWithContext(ctx context.Context) *AddPolicyParams {
	var ()
	return &AddPolicyParams{

		Context: ctx,
	}
}

// NewAddPolicyParamsWithHTTPClient creates a new AddPolicyParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewAddPolicyParamsWithHTTPClient(client *http.Client) *AddPolicyParams {
	var ()
	return &AddPolicyParams{
		HTTPClient: client,
	}
}

/*AddPolicyParams contains all the parameters to send to the API endpoint
for the add policy operation typically these are written to a http.Request
*/
type AddPolicyParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string
	/*Body
	  Policy Object

	*/
	Body *v1.Policy

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the add policy params
func (o *AddPolicyParams) WithTimeout(timeout time.Duration) *AddPolicyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add policy params
func (o *AddPolicyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add policy params
func (o *AddPolicyParams) WithContext(ctx context.Context) *AddPolicyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add policy params
func (o *AddPolicyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add policy params
func (o *AddPolicyParams) WithHTTPClient(client *http.Client) *AddPolicyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add policy params
func (o *AddPolicyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the add policy params
func (o *AddPolicyParams) WithXDispatchOrg(xDispatchOrg string) *AddPolicyParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the add policy params
func (o *AddPolicyParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithBody adds the body to the add policy params
func (o *AddPolicyParams) WithBody(body *v1.Policy) *AddPolicyParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add policy params
func (o *AddPolicyParams) SetBody(body *v1.Policy) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddPolicyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
