///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package policy

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// AddPolicyReader is a Reader for the AddPolicy structure.
type AddPolicyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddPolicyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 201:
		result := NewAddPolicyCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewAddPolicyBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewAddPolicyUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewAddPolicyForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 409:
		result := NewAddPolicyConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewAddPolicyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddPolicyCreated creates a AddPolicyCreated with default headers values
func NewAddPolicyCreated() *AddPolicyCreated {
	return &AddPolicyCreated{}
}

/*AddPolicyCreated handles this case with default header values.

created
*/
type AddPolicyCreated struct {
	Payload *v1.Policy
}

func (o *AddPolicyCreated) Error() string {
	return fmt.Sprintf("[POST /v1/iam/policy][%d] addPolicyCreated  %+v", 201, o.Payload)
}

func (o *AddPolicyCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Policy)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddPolicyBadRequest creates a AddPolicyBadRequest with default headers values
func NewAddPolicyBadRequest() *AddPolicyBadRequest {
	return &AddPolicyBadRequest{}
}

/*AddPolicyBadRequest handles this case with default header values.

Invalid input
*/
type AddPolicyBadRequest struct {
	Payload *v1.Error
}

func (o *AddPolicyBadRequest) Error() string {
	return fmt.Sprintf("[POST /v1/iam/policy][%d] addPolicyBadRequest  %+v", 400, o.Payload)
}

func (o *AddPolicyBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddPolicyUnauthorized creates a AddPolicyUnauthorized with default headers values
func NewAddPolicyUnauthorized() *AddPolicyUnauthorized {
	return &AddPolicyUnauthorized{}
}

/*AddPolicyUnauthorized handles this case with default header values.

Unauthorized Request
*/
type AddPolicyUnauthorized struct {
	Payload *v1.Error
}

func (o *AddPolicyUnauthorized) Error() string {
	return fmt.Sprintf("[POST /v1/iam/policy][%d] addPolicyUnauthorized  %+v", 401, o.Payload)
}

func (o *AddPolicyUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddPolicyForbidden creates a AddPolicyForbidden with default headers values
func NewAddPolicyForbidden() *AddPolicyForbidden {
	return &AddPolicyForbidden{}
}

/*AddPolicyForbidden handles this case with default header values.

access to this resource is forbidden
*/
type AddPolicyForbidden struct {
	Payload *v1.Error
}

func (o *AddPolicyForbidden) Error() string {
	return fmt.Sprintf("[POST /v1/iam/policy][%d] addPolicyForbidden  %+v", 403, o.Payload)
}

func (o *AddPolicyForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddPolicyConflict creates a AddPolicyConflict with default headers values
func NewAddPolicyConflict() *AddPolicyConflict {
	return &AddPolicyConflict{}
}

/*AddPolicyConflict handles this case with default header values.

Already Exists
*/
type AddPolicyConflict struct {
	Payload *v1.Error
}

func (o *AddPolicyConflict) Error() string {
	return fmt.Sprintf("[POST /v1/iam/policy][%d] addPolicyConflict  %+v", 409, o.Payload)
}

func (o *AddPolicyConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddPolicyDefault creates a AddPolicyDefault with default headers values
func NewAddPolicyDefault(code int) *AddPolicyDefault {
	return &AddPolicyDefault{
		_statusCode: code,
	}
}

/*AddPolicyDefault handles this case with default header values.

Generic error response
*/
type AddPolicyDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the add policy default response
func (o *AddPolicyDefault) Code() int {
	return o._statusCode
}

func (o *AddPolicyDefault) Error() string {
	return fmt.Sprintf("[POST /v1/iam/policy][%d] addPolicy default  %+v", o._statusCode, o.Payload)
}

func (o *AddPolicyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
