///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package policy

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetPoliciesParams creates a new GetPoliciesParams object
// with the default values initialized.
func NewGetPoliciesParams() *GetPoliciesParams {
	var ()
	return &GetPoliciesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetPoliciesParamsWithTimeout creates a new GetPoliciesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetPoliciesParamsWithTimeout(timeout time.Duration) *GetPoliciesParams {
	var ()
	return &GetPoliciesParams{

		timeout: timeout,
	}
}

// NewGetPoliciesParamsWithContext creates a new GetPoliciesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetPoliciesParamsWithContext(ctx context.Context) *GetPoliciesParams {
	var ()
	return &GetPoliciesParams{

		Context: ctx,
	}
}

// NewGetPoliciesParamsWithHTTPClient creates a new GetPoliciesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetPoliciesParamsWithHTTPClient(client *http.Client) *GetPoliciesParams {
	var ()
	return &GetPoliciesParams{
		HTTPClient: client,
	}
}

/*GetPoliciesParams contains all the parameters to send to the API endpoint
for the get policies operation typically these are written to a http.Request
*/
type GetPoliciesParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get policies params
func (o *GetPoliciesParams) WithTimeout(timeout time.Duration) *GetPoliciesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get policies params
func (o *GetPoliciesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get policies params
func (o *GetPoliciesParams) WithContext(ctx context.Context) *GetPoliciesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get policies params
func (o *GetPoliciesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get policies params
func (o *GetPoliciesParams) WithHTTPClient(client *http.Client) *GetPoliciesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get policies params
func (o *GetPoliciesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the get policies params
func (o *GetPoliciesParams) WithXDispatchOrg(xDispatchOrg string) *GetPoliciesParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the get policies params
func (o *GetPoliciesParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WriteToRequest writes these params to a swagger request
func (o *GetPoliciesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
