///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package serviceaccount

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetServiceAccountParams creates a new GetServiceAccountParams object
// with the default values initialized.
func NewGetServiceAccountParams() *GetServiceAccountParams {
	var ()
	return &GetServiceAccountParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetServiceAccountParamsWithTimeout creates a new GetServiceAccountParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetServiceAccountParamsWithTimeout(timeout time.Duration) *GetServiceAccountParams {
	var ()
	return &GetServiceAccountParams{

		timeout: timeout,
	}
}

// NewGetServiceAccountParamsWithContext creates a new GetServiceAccountParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetServiceAccountParamsWithContext(ctx context.Context) *GetServiceAccountParams {
	var ()
	return &GetServiceAccountParams{

		Context: ctx,
	}
}

// NewGetServiceAccountParamsWithHTTPClient creates a new GetServiceAccountParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetServiceAccountParamsWithHTTPClient(client *http.Client) *GetServiceAccountParams {
	var ()
	return &GetServiceAccountParams{
		HTTPClient: client,
	}
}

/*GetServiceAccountParams contains all the parameters to send to the API endpoint
for the get service account operation typically these are written to a http.Request
*/
type GetServiceAccountParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string
	/*ServiceAccountName
	  Name of ServiceAccount to work on

	*/
	ServiceAccountName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get service account params
func (o *GetServiceAccountParams) WithTimeout(timeout time.Duration) *GetServiceAccountParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get service account params
func (o *GetServiceAccountParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get service account params
func (o *GetServiceAccountParams) WithContext(ctx context.Context) *GetServiceAccountParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get service account params
func (o *GetServiceAccountParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get service account params
func (o *GetServiceAccountParams) WithHTTPClient(client *http.Client) *GetServiceAccountParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get service account params
func (o *GetServiceAccountParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the get service account params
func (o *GetServiceAccountParams) WithXDispatchOrg(xDispatchOrg string) *GetServiceAccountParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the get service account params
func (o *GetServiceAccountParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithServiceAccountName adds the serviceAccountName to the get service account params
func (o *GetServiceAccountParams) WithServiceAccountName(serviceAccountName string) *GetServiceAccountParams {
	o.SetServiceAccountName(serviceAccountName)
	return o
}

// SetServiceAccountName adds the serviceAccountName to the get service account params
func (o *GetServiceAccountParams) SetServiceAccountName(serviceAccountName string) {
	o.ServiceAccountName = serviceAccountName
}

// WriteToRequest writes these params to a swagger request
func (o *GetServiceAccountParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	// path param serviceAccountName
	if err := r.SetPathParam("serviceAccountName", o.ServiceAccountName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
