///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package serviceaccount

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetServiceAccountsParams creates a new GetServiceAccountsParams object
// with the default values initialized.
func NewGetServiceAccountsParams() *GetServiceAccountsParams {
	var ()
	return &GetServiceAccountsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetServiceAccountsParamsWithTimeout creates a new GetServiceAccountsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetServiceAccountsParamsWithTimeout(timeout time.Duration) *GetServiceAccountsParams {
	var ()
	return &GetServiceAccountsParams{

		timeout: timeout,
	}
}

// NewGetServiceAccountsParamsWithContext creates a new GetServiceAccountsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetServiceAccountsParamsWithContext(ctx context.Context) *GetServiceAccountsParams {
	var ()
	return &GetServiceAccountsParams{

		Context: ctx,
	}
}

// NewGetServiceAccountsParamsWithHTTPClient creates a new GetServiceAccountsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetServiceAccountsParamsWithHTTPClient(client *http.Client) *GetServiceAccountsParams {
	var ()
	return &GetServiceAccountsParams{
		HTTPClient: client,
	}
}

/*GetServiceAccountsParams contains all the parameters to send to the API endpoint
for the get service accounts operation typically these are written to a http.Request
*/
type GetServiceAccountsParams struct {

	/*XDispatchOrg*/
	XDispatchOrg string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get service accounts params
func (o *GetServiceAccountsParams) WithTimeout(timeout time.Duration) *GetServiceAccountsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get service accounts params
func (o *GetServiceAccountsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get service accounts params
func (o *GetServiceAccountsParams) WithContext(ctx context.Context) *GetServiceAccountsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get service accounts params
func (o *GetServiceAccountsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get service accounts params
func (o *GetServiceAccountsParams) WithHTTPClient(client *http.Client) *GetServiceAccountsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get service accounts params
func (o *GetServiceAccountsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the get service accounts params
func (o *GetServiceAccountsParams) WithXDispatchOrg(xDispatchOrg string) *GetServiceAccountsParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the get service accounts params
func (o *GetServiceAccountsParams) SetXDispatchOrg(xDispatchOrg string) {
	o.XDispatchOrg = xDispatchOrg
}

// WriteToRequest writes these params to a swagger request
func (o *GetServiceAccountsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Dispatch-Org
	if err := r.SetHeaderParam("X-Dispatch-Org", o.XDispatchOrg); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
