///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package serviceaccount

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// UpdateServiceAccountReader is a Reader for the UpdateServiceAccount structure.
type UpdateServiceAccountReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateServiceAccountReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewUpdateServiceAccountOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewUpdateServiceAccountBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewUpdateServiceAccountUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewUpdateServiceAccountForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewUpdateServiceAccountNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewUpdateServiceAccountDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateServiceAccountOK creates a UpdateServiceAccountOK with default headers values
func NewUpdateServiceAccountOK() *UpdateServiceAccountOK {
	return &UpdateServiceAccountOK{}
}

/*UpdateServiceAccountOK handles this case with default header values.

Successful update
*/
type UpdateServiceAccountOK struct {
	Payload *v1.ServiceAccount
}

func (o *UpdateServiceAccountOK) Error() string {
	return fmt.Sprintf("[PUT /v1/iam/serviceaccount/{serviceAccountName}][%d] updateServiceAccountOK  %+v", 200, o.Payload)
}

func (o *UpdateServiceAccountOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.ServiceAccount)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateServiceAccountBadRequest creates a UpdateServiceAccountBadRequest with default headers values
func NewUpdateServiceAccountBadRequest() *UpdateServiceAccountBadRequest {
	return &UpdateServiceAccountBadRequest{}
}

/*UpdateServiceAccountBadRequest handles this case with default header values.

Invalid input
*/
type UpdateServiceAccountBadRequest struct {
	Payload *v1.Error
}

func (o *UpdateServiceAccountBadRequest) Error() string {
	return fmt.Sprintf("[PUT /v1/iam/serviceaccount/{serviceAccountName}][%d] updateServiceAccountBadRequest  %+v", 400, o.Payload)
}

func (o *UpdateServiceAccountBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateServiceAccountUnauthorized creates a UpdateServiceAccountUnauthorized with default headers values
func NewUpdateServiceAccountUnauthorized() *UpdateServiceAccountUnauthorized {
	return &UpdateServiceAccountUnauthorized{}
}

/*UpdateServiceAccountUnauthorized handles this case with default header values.

Unauthorized Request
*/
type UpdateServiceAccountUnauthorized struct {
	Payload *v1.Error
}

func (o *UpdateServiceAccountUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /v1/iam/serviceaccount/{serviceAccountName}][%d] updateServiceAccountUnauthorized  %+v", 401, o.Payload)
}

func (o *UpdateServiceAccountUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateServiceAccountForbidden creates a UpdateServiceAccountForbidden with default headers values
func NewUpdateServiceAccountForbidden() *UpdateServiceAccountForbidden {
	return &UpdateServiceAccountForbidden{}
}

/*UpdateServiceAccountForbidden handles this case with default header values.

access to this resource is forbidden
*/
type UpdateServiceAccountForbidden struct {
	Payload *v1.Error
}

func (o *UpdateServiceAccountForbidden) Error() string {
	return fmt.Sprintf("[PUT /v1/iam/serviceaccount/{serviceAccountName}][%d] updateServiceAccountForbidden  %+v", 403, o.Payload)
}

func (o *UpdateServiceAccountForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateServiceAccountNotFound creates a UpdateServiceAccountNotFound with default headers values
func NewUpdateServiceAccountNotFound() *UpdateServiceAccountNotFound {
	return &UpdateServiceAccountNotFound{}
}

/*UpdateServiceAccountNotFound handles this case with default header values.

Service Account not found
*/
type UpdateServiceAccountNotFound struct {
	Payload *v1.Error
}

func (o *UpdateServiceAccountNotFound) Error() string {
	return fmt.Sprintf("[PUT /v1/iam/serviceaccount/{serviceAccountName}][%d] updateServiceAccountNotFound  %+v", 404, o.Payload)
}

func (o *UpdateServiceAccountNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateServiceAccountDefault creates a UpdateServiceAccountDefault with default headers values
func NewUpdateServiceAccountDefault(code int) *UpdateServiceAccountDefault {
	return &UpdateServiceAccountDefault{
		_statusCode: code,
	}
}

/*UpdateServiceAccountDefault handles this case with default header values.

Unknown error
*/
type UpdateServiceAccountDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the update service account default response
func (o *UpdateServiceAccountDefault) Code() int {
	return o._statusCode
}

func (o *UpdateServiceAccountDefault) Error() string {
	return fmt.Sprintf("[PUT /v1/iam/serviceaccount/{serviceAccountName}][%d] updateServiceAccount default  %+v", o._statusCode, o.Payload)
}

func (o *UpdateServiceAccountDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
