///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// HomeOKCode is the HTTP code returned for type HomeOK
const HomeOKCode int = 200

/*HomeOK home page

swagger:response homeOK
*/
type HomeOK struct {

	/*
	  In: Body
	*/
	Payload *v1.Message `json:"body,omitempty"`
}

// NewHomeOK creates HomeOK with default headers values
func NewHomeOK() *HomeOK {

	return &HomeOK{}
}

// WithPayload adds the payload to the home o k response
func (o *HomeOK) WithPayload(payload *v1.Message) *HomeOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the home o k response
func (o *HomeOK) SetPayload(payload *v1.Message) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *HomeOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// HomeUnauthorizedCode is the HTTP code returned for type HomeUnauthorized
const HomeUnauthorizedCode int = 401

/*HomeUnauthorized Unauthorized Request

swagger:response homeUnauthorized
*/
type HomeUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewHomeUnauthorized creates HomeUnauthorized with default headers values
func NewHomeUnauthorized() *HomeUnauthorized {

	return &HomeUnauthorized{}
}

// WithPayload adds the payload to the home unauthorized response
func (o *HomeUnauthorized) WithPayload(payload *v1.Error) *HomeUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the home unauthorized response
func (o *HomeUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *HomeUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// HomeForbiddenCode is the HTTP code returned for type HomeForbidden
const HomeForbiddenCode int = 403

/*HomeForbidden access to this resource is forbidden

swagger:response homeForbidden
*/
type HomeForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewHomeForbidden creates HomeForbidden with default headers values
func NewHomeForbidden() *HomeForbidden {

	return &HomeForbidden{}
}

// WithPayload adds the payload to the home forbidden response
func (o *HomeForbidden) WithPayload(payload *v1.Error) *HomeForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the home forbidden response
func (o *HomeForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *HomeForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*HomeDefault error

swagger:response homeDefault
*/
type HomeDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewHomeDefault creates HomeDefault with default headers values
func NewHomeDefault(code int) *HomeDefault {
	if code <= 0 {
		code = 500
	}

	return &HomeDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the home default response
func (o *HomeDefault) WithStatusCode(code int) *HomeDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the home default response
func (o *HomeDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the home default response
func (o *HomeDefault) WithPayload(payload *v1.Error) *HomeDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the home default response
func (o *HomeDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *HomeDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
