///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// GetOrganizationsOKCode is the HTTP code returned for type GetOrganizationsOK
const GetOrganizationsOKCode int = 200

/*GetOrganizationsOK Successful operation

swagger:response getOrganizationsOK
*/
type GetOrganizationsOK struct {

	/*
	  In: Body
	*/
	Payload []*v1.Organization `json:"body,omitempty"`
}

// NewGetOrganizationsOK creates GetOrganizationsOK with default headers values
func NewGetOrganizationsOK() *GetOrganizationsOK {

	return &GetOrganizationsOK{}
}

// WithPayload adds the payload to the get organizations o k response
func (o *GetOrganizationsOK) WithPayload(payload []*v1.Organization) *GetOrganizationsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get organizations o k response
func (o *GetOrganizationsOK) SetPayload(payload []*v1.Organization) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetOrganizationsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		payload = make([]*v1.Organization, 0, 50)
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}

}

// GetOrganizationsUnauthorizedCode is the HTTP code returned for type GetOrganizationsUnauthorized
const GetOrganizationsUnauthorizedCode int = 401

/*GetOrganizationsUnauthorized Unauthorized Request

swagger:response getOrganizationsUnauthorized
*/
type GetOrganizationsUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetOrganizationsUnauthorized creates GetOrganizationsUnauthorized with default headers values
func NewGetOrganizationsUnauthorized() *GetOrganizationsUnauthorized {

	return &GetOrganizationsUnauthorized{}
}

// WithPayload adds the payload to the get organizations unauthorized response
func (o *GetOrganizationsUnauthorized) WithPayload(payload *v1.Error) *GetOrganizationsUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get organizations unauthorized response
func (o *GetOrganizationsUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetOrganizationsUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetOrganizationsForbiddenCode is the HTTP code returned for type GetOrganizationsForbidden
const GetOrganizationsForbiddenCode int = 403

/*GetOrganizationsForbidden access to this resource is forbidden

swagger:response getOrganizationsForbidden
*/
type GetOrganizationsForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetOrganizationsForbidden creates GetOrganizationsForbidden with default headers values
func NewGetOrganizationsForbidden() *GetOrganizationsForbidden {

	return &GetOrganizationsForbidden{}
}

// WithPayload adds the payload to the get organizations forbidden response
func (o *GetOrganizationsForbidden) WithPayload(payload *v1.Error) *GetOrganizationsForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get organizations forbidden response
func (o *GetOrganizationsForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetOrganizationsForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*GetOrganizationsDefault Unexpected Error

swagger:response getOrganizationsDefault
*/
type GetOrganizationsDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetOrganizationsDefault creates GetOrganizationsDefault with default headers values
func NewGetOrganizationsDefault(code int) *GetOrganizationsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetOrganizationsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get organizations default response
func (o *GetOrganizationsDefault) WithStatusCode(code int) *GetOrganizationsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get organizations default response
func (o *GetOrganizationsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get organizations default response
func (o *GetOrganizationsDefault) WithPayload(payload *v1.Error) *GetOrganizationsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get organizations default response
func (o *GetOrganizationsDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetOrganizationsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
