///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// UpdateOrganizationHandlerFunc turns a function with the right signature into a update organization handler
type UpdateOrganizationHandlerFunc func(UpdateOrganizationParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn UpdateOrganizationHandlerFunc) Handle(params UpdateOrganizationParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// UpdateOrganizationHandler interface for that can handle valid update organization params
type UpdateOrganizationHandler interface {
	Handle(UpdateOrganizationParams, interface{}) middleware.Responder
}

// NewUpdateOrganization creates a new http.Handler for the update organization operation
func NewUpdateOrganization(ctx *middleware.Context, handler UpdateOrganizationHandler) *UpdateOrganization {
	return &UpdateOrganization{Context: ctx, Handler: handler}
}

/*UpdateOrganization swagger:route PUT /v1/iam/organization/{organizationName} organization updateOrganization

Update a Organization

*/
type UpdateOrganization struct {
	Context *middleware.Context
	Handler UpdateOrganizationHandler
}

func (o *UpdateOrganization) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUpdateOrganizationParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
