///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package policy

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// AddPolicyCreatedCode is the HTTP code returned for type AddPolicyCreated
const AddPolicyCreatedCode int = 201

/*AddPolicyCreated created

swagger:response addPolicyCreated
*/
type AddPolicyCreated struct {

	/*
	  In: Body
	*/
	Payload *v1.Policy `json:"body,omitempty"`
}

// NewAddPolicyCreated creates AddPolicyCreated with default headers values
func NewAddPolicyCreated() *AddPolicyCreated {

	return &AddPolicyCreated{}
}

// WithPayload adds the payload to the add policy created response
func (o *AddPolicyCreated) WithPayload(payload *v1.Policy) *AddPolicyCreated {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add policy created response
func (o *AddPolicyCreated) SetPayload(payload *v1.Policy) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddPolicyCreated) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(201)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// AddPolicyBadRequestCode is the HTTP code returned for type AddPolicyBadRequest
const AddPolicyBadRequestCode int = 400

/*AddPolicyBadRequest Invalid input

swagger:response addPolicyBadRequest
*/
type AddPolicyBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewAddPolicyBadRequest creates AddPolicyBadRequest with default headers values
func NewAddPolicyBadRequest() *AddPolicyBadRequest {

	return &AddPolicyBadRequest{}
}

// WithPayload adds the payload to the add policy bad request response
func (o *AddPolicyBadRequest) WithPayload(payload *v1.Error) *AddPolicyBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add policy bad request response
func (o *AddPolicyBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddPolicyBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// AddPolicyUnauthorizedCode is the HTTP code returned for type AddPolicyUnauthorized
const AddPolicyUnauthorizedCode int = 401

/*AddPolicyUnauthorized Unauthorized Request

swagger:response addPolicyUnauthorized
*/
type AddPolicyUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewAddPolicyUnauthorized creates AddPolicyUnauthorized with default headers values
func NewAddPolicyUnauthorized() *AddPolicyUnauthorized {

	return &AddPolicyUnauthorized{}
}

// WithPayload adds the payload to the add policy unauthorized response
func (o *AddPolicyUnauthorized) WithPayload(payload *v1.Error) *AddPolicyUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add policy unauthorized response
func (o *AddPolicyUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddPolicyUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// AddPolicyForbiddenCode is the HTTP code returned for type AddPolicyForbidden
const AddPolicyForbiddenCode int = 403

/*AddPolicyForbidden access to this resource is forbidden

swagger:response addPolicyForbidden
*/
type AddPolicyForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewAddPolicyForbidden creates AddPolicyForbidden with default headers values
func NewAddPolicyForbidden() *AddPolicyForbidden {

	return &AddPolicyForbidden{}
}

// WithPayload adds the payload to the add policy forbidden response
func (o *AddPolicyForbidden) WithPayload(payload *v1.Error) *AddPolicyForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add policy forbidden response
func (o *AddPolicyForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddPolicyForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// AddPolicyConflictCode is the HTTP code returned for type AddPolicyConflict
const AddPolicyConflictCode int = 409

/*AddPolicyConflict Already Exists

swagger:response addPolicyConflict
*/
type AddPolicyConflict struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewAddPolicyConflict creates AddPolicyConflict with default headers values
func NewAddPolicyConflict() *AddPolicyConflict {

	return &AddPolicyConflict{}
}

// WithPayload adds the payload to the add policy conflict response
func (o *AddPolicyConflict) WithPayload(payload *v1.Error) *AddPolicyConflict {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add policy conflict response
func (o *AddPolicyConflict) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddPolicyConflict) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(409)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*AddPolicyDefault Generic error response

swagger:response addPolicyDefault
*/
type AddPolicyDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewAddPolicyDefault creates AddPolicyDefault with default headers values
func NewAddPolicyDefault(code int) *AddPolicyDefault {
	if code <= 0 {
		code = 500
	}

	return &AddPolicyDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the add policy default response
func (o *AddPolicyDefault) WithStatusCode(code int) *AddPolicyDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the add policy default response
func (o *AddPolicyDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the add policy default response
func (o *AddPolicyDefault) WithPayload(payload *v1.Error) *AddPolicyDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the add policy default response
func (o *AddPolicyDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *AddPolicyDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
