///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package policy

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetPolicyParams creates a new GetPolicyParams object
// no default values defined in spec.
func NewGetPolicyParams() GetPolicyParams {

	return GetPolicyParams{}
}

// GetPolicyParams contains all the bound params for the get policy operation
// typically these are obtained from a http.Request
//
// swagger:parameters getPolicy
type GetPolicyParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*
	  Required: true
	  In: header
	*/
	XDispatchOrg string
	/*Name of Policy to work on
	  Required: true
	  Pattern: ^[\w\d\-]+$
	  In: path
	*/
	PolicyName string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewGetPolicyParams() beforehand.
func (o *GetPolicyParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	if err := o.bindXDispatchOrg(r.Header[http.CanonicalHeaderKey("X-Dispatch-Org")], true, route.Formats); err != nil {
		res = append(res, err)
	}

	rPolicyName, rhkPolicyName, _ := route.Params.GetOK("policyName")
	if err := o.bindPolicyName(rPolicyName, rhkPolicyName, route.Formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindXDispatchOrg binds and validates parameter XDispatchOrg from header.
func (o *GetPolicyParams) bindXDispatchOrg(rawData []string, hasKey bool, formats strfmt.Registry) error {
	if !hasKey {
		return errors.Required("X-Dispatch-Org", "header")
	}
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true

	if err := validate.RequiredString("X-Dispatch-Org", "header", raw); err != nil {
		return err
	}

	o.XDispatchOrg = raw

	return nil
}

// bindPolicyName binds and validates parameter PolicyName from path.
func (o *GetPolicyParams) bindPolicyName(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.PolicyName = raw

	if err := o.validatePolicyName(formats); err != nil {
		return err
	}

	return nil
}

// validatePolicyName carries on validations for parameter PolicyName
func (o *GetPolicyParams) validatePolicyName(formats strfmt.Registry) error {

	if err := validate.Pattern("policyName", "path", o.PolicyName, `^[\w\d\-]+$`); err != nil {
		return err
	}

	return nil
}
