///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package policy

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// UpdatePolicyHandlerFunc turns a function with the right signature into a update policy handler
type UpdatePolicyHandlerFunc func(UpdatePolicyParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn UpdatePolicyHandlerFunc) Handle(params UpdatePolicyParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// UpdatePolicyHandler interface for that can handle valid update policy params
type UpdatePolicyHandler interface {
	Handle(UpdatePolicyParams, interface{}) middleware.Responder
}

// NewUpdatePolicy creates a new http.Handler for the update policy operation
func NewUpdatePolicy(ctx *middleware.Context, handler UpdatePolicyHandler) *UpdatePolicy {
	return &UpdatePolicy{Context: ctx, Handler: handler}
}

/*UpdatePolicy swagger:route PUT /v1/iam/policy/{policyName} policy updatePolicy

Update a Policy

*/
type UpdatePolicy struct {
	Context *middleware.Context
	Handler UpdatePolicyHandler
}

func (o *UpdatePolicy) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUpdatePolicyParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
