///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// RedirectHandlerFunc turns a function with the right signature into a redirect handler
type RedirectHandlerFunc func(RedirectParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn RedirectHandlerFunc) Handle(params RedirectParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// RedirectHandler interface for that can handle valid redirect params
type RedirectHandler interface {
	Handle(RedirectParams, interface{}) middleware.Responder
}

// NewRedirect creates a new http.Handler for the redirect operation
func NewRedirect(ctx *middleware.Context, handler RedirectHandler) *Redirect {
	return &Redirect{Context: ctx, Handler: handler}
}

/*Redirect swagger:route GET /v1/iam/redirect redirect

redirect to localhost for vs-cli login (testing)

*/
type Redirect struct {
	Context *middleware.Context
	Handler RedirectHandler
}

func (o *Redirect) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewRedirectParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
