///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"

	strfmt "github.com/go-openapi/strfmt"
)

// NewRedirectParams creates a new RedirectParams object
// no default values defined in spec.
func NewRedirectParams() RedirectParams {

	return RedirectParams{}
}

// RedirectParams contains all the bound params for the redirect operation
// typically these are obtained from a http.Request
//
// swagger:parameters redirect
type RedirectParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*the local server url redirecting to
	  In: query
	*/
	Redirect *string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewRedirectParams() beforehand.
func (o *RedirectParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	qs := runtime.Values(r.URL.Query())

	qRedirect, qhkRedirect, _ := qs.GetOK("redirect")
	if err := o.bindRedirect(qRedirect, qhkRedirect, route.Formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindRedirect binds and validates parameter Redirect from query.
func (o *RedirectParams) bindRedirect(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false
	if raw == "" { // empty values pass all other validations
		return nil
	}

	o.Redirect = &raw

	return nil
}
