///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// RootOKCode is the HTTP code returned for type RootOK
const RootOKCode int = 200

/*RootOK home page

swagger:response rootOK
*/
type RootOK struct {

	/*
	  In: Body
	*/
	Payload *v1.Message `json:"body,omitempty"`
}

// NewRootOK creates RootOK with default headers values
func NewRootOK() *RootOK {

	return &RootOK{}
}

// WithPayload adds the payload to the root o k response
func (o *RootOK) WithPayload(payload *v1.Message) *RootOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the root o k response
func (o *RootOK) SetPayload(payload *v1.Message) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RootOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// RootUnauthorizedCode is the HTTP code returned for type RootUnauthorized
const RootUnauthorizedCode int = 401

/*RootUnauthorized Unauthorized Request

swagger:response rootUnauthorized
*/
type RootUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRootUnauthorized creates RootUnauthorized with default headers values
func NewRootUnauthorized() *RootUnauthorized {

	return &RootUnauthorized{}
}

// WithPayload adds the payload to the root unauthorized response
func (o *RootUnauthorized) WithPayload(payload *v1.Error) *RootUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the root unauthorized response
func (o *RootUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RootUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// RootForbiddenCode is the HTTP code returned for type RootForbidden
const RootForbiddenCode int = 403

/*RootForbidden access to this resource is forbidden

swagger:response rootForbidden
*/
type RootForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRootForbidden creates RootForbidden with default headers values
func NewRootForbidden() *RootForbidden {

	return &RootForbidden{}
}

// WithPayload adds the payload to the root forbidden response
func (o *RootForbidden) WithPayload(payload *v1.Error) *RootForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the root forbidden response
func (o *RootForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RootForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*RootDefault error

swagger:response rootDefault
*/
type RootDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewRootDefault creates RootDefault with default headers values
func NewRootDefault(code int) *RootDefault {
	if code <= 0 {
		code = 500
	}

	return &RootDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the root default response
func (o *RootDefault) WithStatusCode(code int) *RootDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the root default response
func (o *RootDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the root default response
func (o *RootDefault) WithPayload(payload *v1.Error) *RootDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the root default response
func (o *RootDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *RootDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
