///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package serviceaccount

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// AddServiceAccountHandlerFunc turns a function with the right signature into a add service account handler
type AddServiceAccountHandlerFunc func(AddServiceAccountParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn AddServiceAccountHandlerFunc) Handle(params AddServiceAccountParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// AddServiceAccountHandler interface for that can handle valid add service account params
type AddServiceAccountHandler interface {
	Handle(AddServiceAccountParams, interface{}) middleware.Responder
}

// NewAddServiceAccount creates a new http.Handler for the add service account operation
func NewAddServiceAccount(ctx *middleware.Context, handler AddServiceAccountHandler) *AddServiceAccount {
	return &AddServiceAccount{Context: ctx, Handler: handler}
}

/*AddServiceAccount swagger:route POST /v1/iam/serviceaccount serviceaccount addServiceAccount

Add a new service account

*/
type AddServiceAccount struct {
	Context *middleware.Context
	Handler AddServiceAccountHandler
}

func (o *AddServiceAccount) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewAddServiceAccountParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
