///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package serviceaccount

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// DeleteServiceAccountOKCode is the HTTP code returned for type DeleteServiceAccountOK
const DeleteServiceAccountOKCode int = 200

/*DeleteServiceAccountOK Successful operation

swagger:response deleteServiceAccountOK
*/
type DeleteServiceAccountOK struct {

	/*
	  In: Body
	*/
	Payload *v1.ServiceAccount `json:"body,omitempty"`
}

// NewDeleteServiceAccountOK creates DeleteServiceAccountOK with default headers values
func NewDeleteServiceAccountOK() *DeleteServiceAccountOK {

	return &DeleteServiceAccountOK{}
}

// WithPayload adds the payload to the delete service account o k response
func (o *DeleteServiceAccountOK) WithPayload(payload *v1.ServiceAccount) *DeleteServiceAccountOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete service account o k response
func (o *DeleteServiceAccountOK) SetPayload(payload *v1.ServiceAccount) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteServiceAccountOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteServiceAccountBadRequestCode is the HTTP code returned for type DeleteServiceAccountBadRequest
const DeleteServiceAccountBadRequestCode int = 400

/*DeleteServiceAccountBadRequest Invalid Name supplied

swagger:response deleteServiceAccountBadRequest
*/
type DeleteServiceAccountBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteServiceAccountBadRequest creates DeleteServiceAccountBadRequest with default headers values
func NewDeleteServiceAccountBadRequest() *DeleteServiceAccountBadRequest {

	return &DeleteServiceAccountBadRequest{}
}

// WithPayload adds the payload to the delete service account bad request response
func (o *DeleteServiceAccountBadRequest) WithPayload(payload *v1.Error) *DeleteServiceAccountBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete service account bad request response
func (o *DeleteServiceAccountBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteServiceAccountBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteServiceAccountUnauthorizedCode is the HTTP code returned for type DeleteServiceAccountUnauthorized
const DeleteServiceAccountUnauthorizedCode int = 401

/*DeleteServiceAccountUnauthorized Unauthorized Request

swagger:response deleteServiceAccountUnauthorized
*/
type DeleteServiceAccountUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteServiceAccountUnauthorized creates DeleteServiceAccountUnauthorized with default headers values
func NewDeleteServiceAccountUnauthorized() *DeleteServiceAccountUnauthorized {

	return &DeleteServiceAccountUnauthorized{}
}

// WithPayload adds the payload to the delete service account unauthorized response
func (o *DeleteServiceAccountUnauthorized) WithPayload(payload *v1.Error) *DeleteServiceAccountUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete service account unauthorized response
func (o *DeleteServiceAccountUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteServiceAccountUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteServiceAccountForbiddenCode is the HTTP code returned for type DeleteServiceAccountForbidden
const DeleteServiceAccountForbiddenCode int = 403

/*DeleteServiceAccountForbidden access to this resource is forbidden

swagger:response deleteServiceAccountForbidden
*/
type DeleteServiceAccountForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteServiceAccountForbidden creates DeleteServiceAccountForbidden with default headers values
func NewDeleteServiceAccountForbidden() *DeleteServiceAccountForbidden {

	return &DeleteServiceAccountForbidden{}
}

// WithPayload adds the payload to the delete service account forbidden response
func (o *DeleteServiceAccountForbidden) WithPayload(payload *v1.Error) *DeleteServiceAccountForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete service account forbidden response
func (o *DeleteServiceAccountForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteServiceAccountForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// DeleteServiceAccountNotFoundCode is the HTTP code returned for type DeleteServiceAccountNotFound
const DeleteServiceAccountNotFoundCode int = 404

/*DeleteServiceAccountNotFound Service Account not found

swagger:response deleteServiceAccountNotFound
*/
type DeleteServiceAccountNotFound struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteServiceAccountNotFound creates DeleteServiceAccountNotFound with default headers values
func NewDeleteServiceAccountNotFound() *DeleteServiceAccountNotFound {

	return &DeleteServiceAccountNotFound{}
}

// WithPayload adds the payload to the delete service account not found response
func (o *DeleteServiceAccountNotFound) WithPayload(payload *v1.Error) *DeleteServiceAccountNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete service account not found response
func (o *DeleteServiceAccountNotFound) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteServiceAccountNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*DeleteServiceAccountDefault Unknown error

swagger:response deleteServiceAccountDefault
*/
type DeleteServiceAccountDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewDeleteServiceAccountDefault creates DeleteServiceAccountDefault with default headers values
func NewDeleteServiceAccountDefault(code int) *DeleteServiceAccountDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteServiceAccountDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete service account default response
func (o *DeleteServiceAccountDefault) WithStatusCode(code int) *DeleteServiceAccountDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete service account default response
func (o *DeleteServiceAccountDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the delete service account default response
func (o *DeleteServiceAccountDefault) WithPayload(payload *v1.Error) *DeleteServiceAccountDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete service account default response
func (o *DeleteServiceAccountDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteServiceAccountDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
