///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package serviceaccount

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// GetServiceAccountHandlerFunc turns a function with the right signature into a get service account handler
type GetServiceAccountHandlerFunc func(GetServiceAccountParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetServiceAccountHandlerFunc) Handle(params GetServiceAccountParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetServiceAccountHandler interface for that can handle valid get service account params
type GetServiceAccountHandler interface {
	Handle(GetServiceAccountParams, interface{}) middleware.Responder
}

// NewGetServiceAccount creates a new http.Handler for the get service account operation
func NewGetServiceAccount(ctx *middleware.Context, handler GetServiceAccountHandler) *GetServiceAccount {
	return &GetServiceAccount{Context: ctx, Handler: handler}
}

/*GetServiceAccount swagger:route GET /v1/iam/serviceaccount/{serviceAccountName} serviceaccount getServiceAccount

Find Service Account by name

get a Service Account by name

*/
type GetServiceAccount struct {
	Context *middleware.Context
	Handler GetServiceAccountHandler
}

func (o *GetServiceAccount) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetServiceAccountParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
