///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package serviceaccount

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetServiceAccountParams creates a new GetServiceAccountParams object
// no default values defined in spec.
func NewGetServiceAccountParams() GetServiceAccountParams {

	return GetServiceAccountParams{}
}

// GetServiceAccountParams contains all the bound params for the get service account operation
// typically these are obtained from a http.Request
//
// swagger:parameters getServiceAccount
type GetServiceAccountParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*
	  Required: true
	  In: header
	*/
	XDispatchOrg string
	/*Name of ServiceAccount to work on
	  Required: true
	  Pattern: ^[\w\d\-]+$
	  In: path
	*/
	ServiceAccountName string
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewGetServiceAccountParams() beforehand.
func (o *GetServiceAccountParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	if err := o.bindXDispatchOrg(r.Header[http.CanonicalHeaderKey("X-Dispatch-Org")], true, route.Formats); err != nil {
		res = append(res, err)
	}

	rServiceAccountName, rhkServiceAccountName, _ := route.Params.GetOK("serviceAccountName")
	if err := o.bindServiceAccountName(rServiceAccountName, rhkServiceAccountName, route.Formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindXDispatchOrg binds and validates parameter XDispatchOrg from header.
func (o *GetServiceAccountParams) bindXDispatchOrg(rawData []string, hasKey bool, formats strfmt.Registry) error {
	if !hasKey {
		return errors.Required("X-Dispatch-Org", "header")
	}
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true

	if err := validate.RequiredString("X-Dispatch-Org", "header", raw); err != nil {
		return err
	}

	o.XDispatchOrg = raw

	return nil
}

// bindServiceAccountName binds and validates parameter ServiceAccountName from path.
func (o *GetServiceAccountParams) bindServiceAccountName(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: true
	// Parameter is provided by construction from the route

	o.ServiceAccountName = raw

	if err := o.validateServiceAccountName(formats); err != nil {
		return err
	}

	return nil
}

// validateServiceAccountName carries on validations for parameter ServiceAccountName
func (o *GetServiceAccountParams) validateServiceAccountName(formats strfmt.Registry) error {

	if err := validate.Pattern("serviceAccountName", "path", o.ServiceAccountName, `^[\w\d\-]+$`); err != nil {
		return err
	}

	return nil
}
