///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package serviceaccount

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// GetServiceAccountsOKCode is the HTTP code returned for type GetServiceAccountsOK
const GetServiceAccountsOKCode int = 200

/*GetServiceAccountsOK Successful operation

swagger:response getServiceAccountsOK
*/
type GetServiceAccountsOK struct {

	/*
	  In: Body
	*/
	Payload []*v1.ServiceAccount `json:"body,omitempty"`
}

// NewGetServiceAccountsOK creates GetServiceAccountsOK with default headers values
func NewGetServiceAccountsOK() *GetServiceAccountsOK {

	return &GetServiceAccountsOK{}
}

// WithPayload adds the payload to the get service accounts o k response
func (o *GetServiceAccountsOK) WithPayload(payload []*v1.ServiceAccount) *GetServiceAccountsOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get service accounts o k response
func (o *GetServiceAccountsOK) SetPayload(payload []*v1.ServiceAccount) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetServiceAccountsOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		payload = make([]*v1.ServiceAccount, 0, 50)
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}

}

// GetServiceAccountsUnauthorizedCode is the HTTP code returned for type GetServiceAccountsUnauthorized
const GetServiceAccountsUnauthorizedCode int = 401

/*GetServiceAccountsUnauthorized Unauthorized Request

swagger:response getServiceAccountsUnauthorized
*/
type GetServiceAccountsUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetServiceAccountsUnauthorized creates GetServiceAccountsUnauthorized with default headers values
func NewGetServiceAccountsUnauthorized() *GetServiceAccountsUnauthorized {

	return &GetServiceAccountsUnauthorized{}
}

// WithPayload adds the payload to the get service accounts unauthorized response
func (o *GetServiceAccountsUnauthorized) WithPayload(payload *v1.Error) *GetServiceAccountsUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get service accounts unauthorized response
func (o *GetServiceAccountsUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetServiceAccountsUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetServiceAccountsForbiddenCode is the HTTP code returned for type GetServiceAccountsForbidden
const GetServiceAccountsForbiddenCode int = 403

/*GetServiceAccountsForbidden access to this resource is forbidden

swagger:response getServiceAccountsForbidden
*/
type GetServiceAccountsForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetServiceAccountsForbidden creates GetServiceAccountsForbidden with default headers values
func NewGetServiceAccountsForbidden() *GetServiceAccountsForbidden {

	return &GetServiceAccountsForbidden{}
}

// WithPayload adds the payload to the get service accounts forbidden response
func (o *GetServiceAccountsForbidden) WithPayload(payload *v1.Error) *GetServiceAccountsForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get service accounts forbidden response
func (o *GetServiceAccountsForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetServiceAccountsForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*GetServiceAccountsDefault Unexpected Error

swagger:response getServiceAccountsDefault
*/
type GetServiceAccountsDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetServiceAccountsDefault creates GetServiceAccountsDefault with default headers values
func NewGetServiceAccountsDefault(code int) *GetServiceAccountsDefault {
	if code <= 0 {
		code = 500
	}

	return &GetServiceAccountsDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get service accounts default response
func (o *GetServiceAccountsDefault) WithStatusCode(code int) *GetServiceAccountsDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get service accounts default response
func (o *GetServiceAccountsDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get service accounts default response
func (o *GetServiceAccountsDefault) WithPayload(payload *v1.Error) *GetServiceAccountsDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get service accounts default response
func (o *GetServiceAccountsDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetServiceAccountsDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
