///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package serviceaccount

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// UpdateServiceAccountHandlerFunc turns a function with the right signature into a update service account handler
type UpdateServiceAccountHandlerFunc func(UpdateServiceAccountParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn UpdateServiceAccountHandlerFunc) Handle(params UpdateServiceAccountParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// UpdateServiceAccountHandler interface for that can handle valid update service account params
type UpdateServiceAccountHandler interface {
	Handle(UpdateServiceAccountParams, interface{}) middleware.Responder
}

// NewUpdateServiceAccount creates a new http.Handler for the update service account operation
func NewUpdateServiceAccount(ctx *middleware.Context, handler UpdateServiceAccountHandler) *UpdateServiceAccount {
	return &UpdateServiceAccount{Context: ctx, Handler: handler}
}

/*UpdateServiceAccount swagger:route PUT /v1/iam/serviceaccount/{serviceAccountName} serviceaccount updateServiceAccount

Update a Service Account

*/
type UpdateServiceAccount struct {
	Context *middleware.Context
	Handler UpdateServiceAccountHandler
}

func (o *UpdateServiceAccount) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUpdateServiceAccountParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
