///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package image

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// GetImagesReader is a Reader for the GetImages structure.
type GetImagesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetImagesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetImagesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewGetImagesBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewGetImagesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewGetImagesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewGetImagesDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetImagesOK creates a GetImagesOK with default headers values
func NewGetImagesOK() *GetImagesOK {
	return &GetImagesOK{}
}

/*GetImagesOK handles this case with default header values.

successful operation
*/
type GetImagesOK struct {
	Payload []*v1.Image
}

func (o *GetImagesOK) Error() string {
	return fmt.Sprintf("[GET /][%d] getImagesOK  %+v", 200, o.Payload)
}

func (o *GetImagesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetImagesBadRequest creates a GetImagesBadRequest with default headers values
func NewGetImagesBadRequest() *GetImagesBadRequest {
	return &GetImagesBadRequest{}
}

/*GetImagesBadRequest handles this case with default header values.

Invalid input
*/
type GetImagesBadRequest struct {
	Payload *v1.Error
}

func (o *GetImagesBadRequest) Error() string {
	return fmt.Sprintf("[GET /][%d] getImagesBadRequest  %+v", 400, o.Payload)
}

func (o *GetImagesBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetImagesUnauthorized creates a GetImagesUnauthorized with default headers values
func NewGetImagesUnauthorized() *GetImagesUnauthorized {
	return &GetImagesUnauthorized{}
}

/*GetImagesUnauthorized handles this case with default header values.

Unauthorized Request
*/
type GetImagesUnauthorized struct {
	Payload *v1.Error
}

func (o *GetImagesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /][%d] getImagesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetImagesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetImagesForbidden creates a GetImagesForbidden with default headers values
func NewGetImagesForbidden() *GetImagesForbidden {
	return &GetImagesForbidden{}
}

/*GetImagesForbidden handles this case with default header values.

access to this resource is forbidden
*/
type GetImagesForbidden struct {
	Payload *v1.Error
}

func (o *GetImagesForbidden) Error() string {
	return fmt.Sprintf("[GET /][%d] getImagesForbidden  %+v", 403, o.Payload)
}

func (o *GetImagesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetImagesDefault creates a GetImagesDefault with default headers values
func NewGetImagesDefault(code int) *GetImagesDefault {
	return &GetImagesDefault{
		_statusCode: code,
	}
}

/*GetImagesDefault handles this case with default header values.

Generic error response
*/
type GetImagesDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the get images default response
func (o *GetImagesDefault) Code() int {
	return o._statusCode
}

func (o *GetImagesDefault) Error() string {
	return fmt.Sprintf("[GET /][%d] getImages default  %+v", o._statusCode, o.Payload)
}

func (o *GetImagesDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
