///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package image

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// NewUpdateImageByNameParams creates a new UpdateImageByNameParams object
// with the default values initialized.
func NewUpdateImageByNameParams() *UpdateImageByNameParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &UpdateImageByNameParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateImageByNameParamsWithTimeout creates a new UpdateImageByNameParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewUpdateImageByNameParamsWithTimeout(timeout time.Duration) *UpdateImageByNameParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &UpdateImageByNameParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: timeout,
	}
}

// NewUpdateImageByNameParamsWithContext creates a new UpdateImageByNameParams object
// with the default values initialized, and the ability to set a context for a request
func NewUpdateImageByNameParamsWithContext(ctx context.Context) *UpdateImageByNameParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &UpdateImageByNameParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		Context: ctx,
	}
}

// NewUpdateImageByNameParamsWithHTTPClient creates a new UpdateImageByNameParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewUpdateImageByNameParamsWithHTTPClient(client *http.Client) *UpdateImageByNameParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &UpdateImageByNameParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,
		HTTPClient:       client,
	}
}

/*UpdateImageByNameParams contains all the parameters to send to the API endpoint
for the update image by name operation typically these are written to a http.Request
*/
type UpdateImageByNameParams struct {

	/*XDispatchOrg*/
	XDispatchOrg *string
	/*XDispatchProject*/
	XDispatchProject *string
	/*Body*/
	Body *v1.Image
	/*ImageName
	  Name of image to return

	*/
	ImageName string
	/*Tags
	  Filter on image tags

	*/
	Tags []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the update image by name params
func (o *UpdateImageByNameParams) WithTimeout(timeout time.Duration) *UpdateImageByNameParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update image by name params
func (o *UpdateImageByNameParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update image by name params
func (o *UpdateImageByNameParams) WithContext(ctx context.Context) *UpdateImageByNameParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update image by name params
func (o *UpdateImageByNameParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update image by name params
func (o *UpdateImageByNameParams) WithHTTPClient(client *http.Client) *UpdateImageByNameParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update image by name params
func (o *UpdateImageByNameParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the update image by name params
func (o *UpdateImageByNameParams) WithXDispatchOrg(xDispatchOrg *string) *UpdateImageByNameParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the update image by name params
func (o *UpdateImageByNameParams) SetXDispatchOrg(xDispatchOrg *string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithXDispatchProject adds the xDispatchProject to the update image by name params
func (o *UpdateImageByNameParams) WithXDispatchProject(xDispatchProject *string) *UpdateImageByNameParams {
	o.SetXDispatchProject(xDispatchProject)
	return o
}

// SetXDispatchProject adds the xDispatchProject to the update image by name params
func (o *UpdateImageByNameParams) SetXDispatchProject(xDispatchProject *string) {
	o.XDispatchProject = xDispatchProject
}

// WithBody adds the body to the update image by name params
func (o *UpdateImageByNameParams) WithBody(body *v1.Image) *UpdateImageByNameParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update image by name params
func (o *UpdateImageByNameParams) SetBody(body *v1.Image) {
	o.Body = body
}

// WithImageName adds the imageName to the update image by name params
func (o *UpdateImageByNameParams) WithImageName(imageName string) *UpdateImageByNameParams {
	o.SetImageName(imageName)
	return o
}

// SetImageName adds the imageName to the update image by name params
func (o *UpdateImageByNameParams) SetImageName(imageName string) {
	o.ImageName = imageName
}

// WithTags adds the tags to the update image by name params
func (o *UpdateImageByNameParams) WithTags(tags []string) *UpdateImageByNameParams {
	o.SetTags(tags)
	return o
}

// SetTags adds the tags to the update image by name params
func (o *UpdateImageByNameParams) SetTags(tags []string) {
	o.Tags = tags
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateImageByNameParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XDispatchOrg != nil {

		// header param X-Dispatch-Org
		if err := r.SetHeaderParam("X-Dispatch-Org", *o.XDispatchOrg); err != nil {
			return err
		}

	}

	if o.XDispatchProject != nil {

		// header param X-Dispatch-Project
		if err := r.SetHeaderParam("X-Dispatch-Project", *o.XDispatchProject); err != nil {
			return err
		}

	}

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param imageName
	if err := r.SetPathParam("imageName", o.ImageName); err != nil {
		return err
	}

	valuesTags := o.Tags

	joinedTags := swag.JoinByFormat(valuesTags, "multi")
	// query array param tags
	if err := r.SetQueryParam("tags", joinedTags...); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
