///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package image

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// GetImagesOKCode is the HTTP code returned for type GetImagesOK
const GetImagesOKCode int = 200

/*GetImagesOK successful operation

swagger:response getImagesOK
*/
type GetImagesOK struct {

	/*
	  In: Body
	*/
	Payload []*v1.Image `json:"body,omitempty"`
}

// NewGetImagesOK creates GetImagesOK with default headers values
func NewGetImagesOK() *GetImagesOK {

	return &GetImagesOK{}
}

// WithPayload adds the payload to the get images o k response
func (o *GetImagesOK) WithPayload(payload []*v1.Image) *GetImagesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get images o k response
func (o *GetImagesOK) SetPayload(payload []*v1.Image) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetImagesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		payload = make([]*v1.Image, 0, 50)
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}

}

// GetImagesBadRequestCode is the HTTP code returned for type GetImagesBadRequest
const GetImagesBadRequestCode int = 400

/*GetImagesBadRequest Invalid input

swagger:response getImagesBadRequest
*/
type GetImagesBadRequest struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetImagesBadRequest creates GetImagesBadRequest with default headers values
func NewGetImagesBadRequest() *GetImagesBadRequest {

	return &GetImagesBadRequest{}
}

// WithPayload adds the payload to the get images bad request response
func (o *GetImagesBadRequest) WithPayload(payload *v1.Error) *GetImagesBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get images bad request response
func (o *GetImagesBadRequest) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetImagesBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetImagesUnauthorizedCode is the HTTP code returned for type GetImagesUnauthorized
const GetImagesUnauthorizedCode int = 401

/*GetImagesUnauthorized Unauthorized Request

swagger:response getImagesUnauthorized
*/
type GetImagesUnauthorized struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetImagesUnauthorized creates GetImagesUnauthorized with default headers values
func NewGetImagesUnauthorized() *GetImagesUnauthorized {

	return &GetImagesUnauthorized{}
}

// WithPayload adds the payload to the get images unauthorized response
func (o *GetImagesUnauthorized) WithPayload(payload *v1.Error) *GetImagesUnauthorized {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get images unauthorized response
func (o *GetImagesUnauthorized) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetImagesUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(401)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetImagesForbiddenCode is the HTTP code returned for type GetImagesForbidden
const GetImagesForbiddenCode int = 403

/*GetImagesForbidden access to this resource is forbidden

swagger:response getImagesForbidden
*/
type GetImagesForbidden struct {

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetImagesForbidden creates GetImagesForbidden with default headers values
func NewGetImagesForbidden() *GetImagesForbidden {

	return &GetImagesForbidden{}
}

// WithPayload adds the payload to the get images forbidden response
func (o *GetImagesForbidden) WithPayload(payload *v1.Error) *GetImagesForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get images forbidden response
func (o *GetImagesForbidden) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetImagesForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*GetImagesDefault Generic error response

swagger:response getImagesDefault
*/
type GetImagesDefault struct {
	_statusCode int

	/*
	  In: Body
	*/
	Payload *v1.Error `json:"body,omitempty"`
}

// NewGetImagesDefault creates GetImagesDefault with default headers values
func NewGetImagesDefault(code int) *GetImagesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetImagesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get images default response
func (o *GetImagesDefault) WithStatusCode(code int) *GetImagesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get images default response
func (o *GetImagesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithPayload adds the payload to the get images default response
func (o *GetImagesDefault) WithPayload(payload *v1.Error) *GetImagesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get images default response
func (o *GetImagesDefault) SetPayload(payload *v1.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetImagesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
