///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	time "time"

	baseimagev1 "github.com/vmware/dispatch/pkg/resources/baseimage/v1"
	versioned "github.com/vmware/dispatch/pkg/resources/gen/clientset/versioned"
	internalinterfaces "github.com/vmware/dispatch/pkg/resources/gen/informers/externalversions/internalinterfaces"
	v1 "github.com/vmware/dispatch/pkg/resources/gen/listers/baseimage/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// BaseImageInformer provides access to a shared informer and lister for
// BaseImages.
type BaseImageInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.BaseImageLister
}

type baseImageInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewBaseImageInformer constructs a new informer for BaseImage type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewBaseImageInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredBaseImageInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredBaseImageInformer constructs a new informer for BaseImage type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredBaseImageInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ResourcesV1().BaseImages(namespace).List(options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ResourcesV1().BaseImages(namespace).Watch(options)
			},
		},
		&baseimagev1.BaseImage{},
		resyncPeriod,
		indexers,
	)
}

func (f *baseImageInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredBaseImageInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *baseImageInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&baseimagev1.BaseImage{}, f.defaultInformer)
}

func (f *baseImageInformer) Lister() v1.BaseImageLister {
	return v1.NewBaseImageLister(f.Informer().GetIndexer())
}
