///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package secret

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// NewAddSecretParams creates a new AddSecretParams object
// with the default values initialized.
func NewAddSecretParams() *AddSecretParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &AddSecretParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewAddSecretParamsWithTimeout creates a new AddSecretParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewAddSecretParamsWithTimeout(timeout time.Duration) *AddSecretParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &AddSecretParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: timeout,
	}
}

// NewAddSecretParamsWithContext creates a new AddSecretParams object
// with the default values initialized, and the ability to set a context for a request
func NewAddSecretParamsWithContext(ctx context.Context) *AddSecretParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &AddSecretParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		Context: ctx,
	}
}

// NewAddSecretParamsWithHTTPClient creates a new AddSecretParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewAddSecretParamsWithHTTPClient(client *http.Client) *AddSecretParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &AddSecretParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,
		HTTPClient:       client,
	}
}

/*AddSecretParams contains all the parameters to send to the API endpoint
for the add secret operation typically these are written to a http.Request
*/
type AddSecretParams struct {

	/*XDispatchOrg*/
	XDispatchOrg *string
	/*XDispatchProject*/
	XDispatchProject *string
	/*Secret*/
	Secret *v1.Secret

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the add secret params
func (o *AddSecretParams) WithTimeout(timeout time.Duration) *AddSecretParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add secret params
func (o *AddSecretParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add secret params
func (o *AddSecretParams) WithContext(ctx context.Context) *AddSecretParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add secret params
func (o *AddSecretParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add secret params
func (o *AddSecretParams) WithHTTPClient(client *http.Client) *AddSecretParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add secret params
func (o *AddSecretParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the add secret params
func (o *AddSecretParams) WithXDispatchOrg(xDispatchOrg *string) *AddSecretParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the add secret params
func (o *AddSecretParams) SetXDispatchOrg(xDispatchOrg *string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithXDispatchProject adds the xDispatchProject to the add secret params
func (o *AddSecretParams) WithXDispatchProject(xDispatchProject *string) *AddSecretParams {
	o.SetXDispatchProject(xDispatchProject)
	return o
}

// SetXDispatchProject adds the xDispatchProject to the add secret params
func (o *AddSecretParams) SetXDispatchProject(xDispatchProject *string) {
	o.XDispatchProject = xDispatchProject
}

// WithSecret adds the secret to the add secret params
func (o *AddSecretParams) WithSecret(secret *v1.Secret) *AddSecretParams {
	o.SetSecret(secret)
	return o
}

// SetSecret adds the secret to the add secret params
func (o *AddSecretParams) SetSecret(secret *v1.Secret) {
	o.Secret = secret
}

// WriteToRequest writes these params to a swagger request
func (o *AddSecretParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XDispatchOrg != nil {

		// header param X-Dispatch-Org
		if err := r.SetHeaderParam("X-Dispatch-Org", *o.XDispatchOrg); err != nil {
			return err
		}

	}

	if o.XDispatchProject != nil {

		// header param X-Dispatch-Project
		if err := r.SetHeaderParam("X-Dispatch-Project", *o.XDispatchProject); err != nil {
			return err
		}

	}

	if o.Secret != nil {
		if err := r.SetBodyParam(o.Secret); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
