///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package secret

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/vmware/dispatch/pkg/api/v1"
)

// AddSecretReader is a Reader for the AddSecret structure.
type AddSecretReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddSecretReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 201:
		result := NewAddSecretCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewAddSecretBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 401:
		result := NewAddSecretUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 403:
		result := NewAddSecretForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 409:
		result := NewAddSecretConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		result := NewAddSecretDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddSecretCreated creates a AddSecretCreated with default headers values
func NewAddSecretCreated() *AddSecretCreated {
	return &AddSecretCreated{}
}

/*AddSecretCreated handles this case with default header values.

The created secret.
*/
type AddSecretCreated struct {
	Payload *v1.Secret
}

func (o *AddSecretCreated) Error() string {
	return fmt.Sprintf("[POST /][%d] addSecretCreated  %+v", 201, o.Payload)
}

func (o *AddSecretCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Secret)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddSecretBadRequest creates a AddSecretBadRequest with default headers values
func NewAddSecretBadRequest() *AddSecretBadRequest {
	return &AddSecretBadRequest{}
}

/*AddSecretBadRequest handles this case with default header values.

Bad Request
*/
type AddSecretBadRequest struct {
	Payload *v1.Error
}

func (o *AddSecretBadRequest) Error() string {
	return fmt.Sprintf("[POST /][%d] addSecretBadRequest  %+v", 400, o.Payload)
}

func (o *AddSecretBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddSecretUnauthorized creates a AddSecretUnauthorized with default headers values
func NewAddSecretUnauthorized() *AddSecretUnauthorized {
	return &AddSecretUnauthorized{}
}

/*AddSecretUnauthorized handles this case with default header values.

Unauthorized Request
*/
type AddSecretUnauthorized struct {
	Payload *v1.Error
}

func (o *AddSecretUnauthorized) Error() string {
	return fmt.Sprintf("[POST /][%d] addSecretUnauthorized  %+v", 401, o.Payload)
}

func (o *AddSecretUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddSecretForbidden creates a AddSecretForbidden with default headers values
func NewAddSecretForbidden() *AddSecretForbidden {
	return &AddSecretForbidden{}
}

/*AddSecretForbidden handles this case with default header values.

access to this resource is forbidden
*/
type AddSecretForbidden struct {
	Payload *v1.Error
}

func (o *AddSecretForbidden) Error() string {
	return fmt.Sprintf("[POST /][%d] addSecretForbidden  %+v", 403, o.Payload)
}

func (o *AddSecretForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddSecretConflict creates a AddSecretConflict with default headers values
func NewAddSecretConflict() *AddSecretConflict {
	return &AddSecretConflict{}
}

/*AddSecretConflict handles this case with default header values.

Already Exists
*/
type AddSecretConflict struct {
	Payload *v1.Error
}

func (o *AddSecretConflict) Error() string {
	return fmt.Sprintf("[POST /][%d] addSecretConflict  %+v", 409, o.Payload)
}

func (o *AddSecretConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddSecretDefault creates a AddSecretDefault with default headers values
func NewAddSecretDefault(code int) *AddSecretDefault {
	return &AddSecretDefault{
		_statusCode: code,
	}
}

/*AddSecretDefault handles this case with default header values.

Standard error
*/
type AddSecretDefault struct {
	_statusCode int

	Payload *v1.Error
}

// Code gets the status code for the add secret default response
func (o *AddSecretDefault) Code() int {
	return o._statusCode
}

func (o *AddSecretDefault) Error() string {
	return fmt.Sprintf("[POST /][%d] addSecret default  %+v", o._statusCode, o.Payload)
}

func (o *AddSecretDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(v1.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
