///////////////////////////////////////////////////////////////////////
// Copyright (c) 2017 VMware, Inc. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
///////////////////////////////////////////////////////////////////////

// Code generated by go-swagger; DO NOT EDIT.

package secret

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetSecretParams creates a new GetSecretParams object
// with the default values initialized.
func NewGetSecretParams() *GetSecretParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &GetSecretParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetSecretParamsWithTimeout creates a new GetSecretParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetSecretParamsWithTimeout(timeout time.Duration) *GetSecretParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &GetSecretParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		timeout: timeout,
	}
}

// NewGetSecretParamsWithContext creates a new GetSecretParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetSecretParamsWithContext(ctx context.Context) *GetSecretParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &GetSecretParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,

		Context: ctx,
	}
}

// NewGetSecretParamsWithHTTPClient creates a new GetSecretParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetSecretParamsWithHTTPClient(client *http.Client) *GetSecretParams {
	var (
		xDispatchOrgDefault     = string("default")
		xDispatchProjectDefault = string("default")
	)
	return &GetSecretParams{
		XDispatchOrg:     &xDispatchOrgDefault,
		XDispatchProject: &xDispatchProjectDefault,
		HTTPClient:       client,
	}
}

/*GetSecretParams contains all the parameters to send to the API endpoint
for the get secret operation typically these are written to a http.Request
*/
type GetSecretParams struct {

	/*XDispatchOrg*/
	XDispatchOrg *string
	/*XDispatchProject*/
	XDispatchProject *string
	/*SecretName
	  name of the secret to operate on

	*/
	SecretName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get secret params
func (o *GetSecretParams) WithTimeout(timeout time.Duration) *GetSecretParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get secret params
func (o *GetSecretParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get secret params
func (o *GetSecretParams) WithContext(ctx context.Context) *GetSecretParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get secret params
func (o *GetSecretParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get secret params
func (o *GetSecretParams) WithHTTPClient(client *http.Client) *GetSecretParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get secret params
func (o *GetSecretParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXDispatchOrg adds the xDispatchOrg to the get secret params
func (o *GetSecretParams) WithXDispatchOrg(xDispatchOrg *string) *GetSecretParams {
	o.SetXDispatchOrg(xDispatchOrg)
	return o
}

// SetXDispatchOrg adds the xDispatchOrg to the get secret params
func (o *GetSecretParams) SetXDispatchOrg(xDispatchOrg *string) {
	o.XDispatchOrg = xDispatchOrg
}

// WithXDispatchProject adds the xDispatchProject to the get secret params
func (o *GetSecretParams) WithXDispatchProject(xDispatchProject *string) *GetSecretParams {
	o.SetXDispatchProject(xDispatchProject)
	return o
}

// SetXDispatchProject adds the xDispatchProject to the get secret params
func (o *GetSecretParams) SetXDispatchProject(xDispatchProject *string) {
	o.XDispatchProject = xDispatchProject
}

// WithSecretName adds the secretName to the get secret params
func (o *GetSecretParams) WithSecretName(secretName string) *GetSecretParams {
	o.SetSecretName(secretName)
	return o
}

// SetSecretName adds the secretName to the get secret params
func (o *GetSecretParams) SetSecretName(secretName string) {
	o.SecretName = secretName
}

// WriteToRequest writes these params to a swagger request
func (o *GetSecretParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XDispatchOrg != nil {

		// header param X-Dispatch-Org
		if err := r.SetHeaderParam("X-Dispatch-Org", *o.XDispatchOrg); err != nil {
			return err
		}

	}

	if o.XDispatchProject != nil {

		// header param X-Dispatch-Project
		if err := r.SetHeaderParam("X-Dispatch-Project", *o.XDispatchProject); err != nil {
			return err
		}

	}

	// path param secretName
	if err := r.SetPathParam("secretName", o.SecretName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
