#!/usr/bin/env bash
# Bash completion for dispatch CLI command
# Generated by cli_taxo

_dispatch_complete () {

    local cur="${COMP_WORDS[COMP_CWORD]}"
    local prev="${COMP_WORDS[COMP_CWORD-1]}"

    echo "${COMP_WORDS[@]}" | grep -q '-' && {
        i=0
        until echo "${COMP_WORDS[i]}" | grep -q '-' ; do ((i++)); done
        prev="${COMP_WORDS[i-1]}"
    }
    
    case "$prev" in
                help)    cmds="-h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        image)    cmds="-a, --application string -h, --help --runtime-deps string --system-deps string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        manage)    cmds="bootstrap context -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        dispatch)    cmds="create delete emit exec get help iam install log login logout manage uninstall update version --config string -h, --help --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        api)    cmds="-a, --application string --auth string --cors --disable -d, --domain stringArray -h, --help --https-only -m, --method stringArray -p, --path stringArray --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -f, --func string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        iam)    cmds="create delete get update -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        log)    cmds="-f, --follow -h, --help -n, --namespace string -t, --tail int --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        create)    cmds="api application base-image eventdriver function image secret seed-images subscription -a, --application string -f, --file string -h, --help -w, --work-dir string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string organization policy -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        serviceclass)    cmds="-h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        application)    cmds="-h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        secret)    cmds="-a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string --all -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        version)    cmds="-h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        policy)    cmds="-a, --action stringSlice --global -h, --help -r, --resource stringSlice -s, --subject stringSlice --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -h, --help -w, --wide --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        get)    cmds="api application base-image eventdriver function image run secret serviceclass subscription -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string organization policy -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        function)    cmds="-a, --application string --handler string -h, --help --image string --schema-in string --schema-out string --secret stringArray --service stringArray --timeout int --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        run)    cmds="-a, --application string -f, --follow -h, --help --last --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        context)    cmds="-h, --help -s, --set string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        exec)    cmds="--all -a, --application string -h, --help --input string --secret stringArray --wait --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        seed-images)    cmds="-h, --help -O, --output-file string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        update)    cmds="-f, --file string -h, --help -w, --work-dir string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -f, --file string -h, --help -w, --work-dir string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        logout)    cmds="-h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        eventdriver)    cmds="-a, --application string -h, --help --name string --secret stringArray -s, --set stringArray --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        subscription)    cmds="-a, --application string --event-type string -h, --help --name string --secret stringArray --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -a, --application string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        bootstrap)    cmds="--bootstrap-org string --bootstrap-svc-account string --bootstrap-user string -d, --disable -h, --help --kubeconfig string --timeout duration --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        base-image)    cmds="-h, --help --language string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        install)    cmds="--charts-dir string --charts-repo string --debug -d, --destination string --dry-run -f, --file string -h, --help --ignore-helm-check -s, --service stringArray --single-namespace string --tiller-namespace string -t, --timeout int --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        organization)    cmds="-h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        login)    cmds="--debug -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        uninstall)    cmds="--debug --dry-run -f, --file string -h, --help --keep-namespaces --remove-cert-files -s, --service stringArray --single-namespace string --tiller-namespace string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        emit)    cmds="--binary --content-type string --data string --data-from-file string --event-id string --event-schema-url string --event-type-version string -h, --help --source-id string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        delete)    cmds="api application base-image eventdriver function image secret subscription -f, --file string -h, --help -w, --work-dir string --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string organization policy -h, --help --config string --host string --insecure --json --jwt-private-key string --organization string --port int --scheme string --service-account string --token string";;
        *)    cmds="help image manage dispatch api iam log create serviceclass application secret version policy get function run context exec seed-images update logout eventdriver subscription bootstrap base-image install organization login uninstall emit delete";;
    esac

    COMPREPLY=( $(compgen -W "$cmds" -- "$cur") )

    return 0
}

complete -F _dispatch_complete dispatch

